
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Extras")){
if(AjxPackage.define("ajax.dwt.widgets.DwtSpinner")){
DwtSpinner=function(e){
if(arguments.length==0){
return
}
DwtControl.call(this,{
parent:e.parent,className:e.className,posStyle:e.posStyle,parentElement:e.parentElement}
);
this._maxValue=e.max!=null?e.max:null;
this._minValue=e.min!=null?e.min:null;
this._fieldSize=e.size!=null?e.size:3;
this._origValue=e.value||0;
this._maxLen=e.maxLen||null;
this._step=e.step||1;
this._decimals="decimals" in e?e.decimals:0;
this._align=e.align||null;
this._timerFunc=AjxCallback.simpleClosure(this._timerFunc,this);
this._btnPressCapture=new DwtMouseEventCapture({
targetObj:this,id:"DwtSpinner",mouseUpHdlr:AjxCallback.simpleClosure(this._stopCapture,this)}
);
this._createElements()
};
DwtSpinner.prototype=new DwtControl;
DwtSpinner.prototype.constructor=DwtSpinner;
DwtSpinner.INIT_TIMER=250;
DwtSpinner.SLOW_TIMER=125;
DwtSpinner.FAST_TIMER=33;
DwtSpinner.prototype._createElements=function(){
var n=this.getHtmlElement();
var o=Dwt.getNextId();
this._idField=o;
this._idUpButton=o+"-up";
this._idDownButton=o+"-down";
var i=["<table class='DwtSpinner' cellspacing='0' cellpadding='0'>","<tr><td rowspan='2' class='DwtSpinner-inputCell'>","<input id='",o,"' autocomplete='off' />","</td>","<td unselectable id='",this._idUpButton,"' class='DwtSpinner-upBtn'><div class='ImgUpArrowSmall'>&nbsp;</div></td>","</tr><tr>","<td unselectable id='",this._idDownButton,"' class='DwtSpinner-downBtn'><div class='ImgDownArrowSmall'>&nbsp;</div></td>","</tr></table>"];
n.innerHTML=i.join("");
var a=this._getUpButton();
a.onmousedown=AjxCallback.simpleClosure(this._btnPressed,this,"Up");
var t=this._getDownButton();
t.onmousedown=AjxCallback.simpleClosure(this._btnPressed,this,"Down");
var e=this.getInputElement();
if(this._maxLen){
e.maxLength=this._maxLen
}
if(this._fieldSize){
e.size=this._fieldSize
}
if(this._align){
e.style.textAlign=this._align
}
if(this._origValue!=null){
this.setValue(this._origValue)
}
e.onblur=AjxCallback.simpleClosure(this.setValue,this,null);
e[(AjxEnv.isIE||AjxEnv.isOpera)?"onkeydown":"onkeypress"]=AjxCallback.simpleClosure(this.__onKeyPress,this)
};
DwtSpinner.prototype._getValidValue=function(e){
var t=parseFloat(e);
if(isNaN(t)||t==null){
t=this._lastValidValue
}
if(t==null){
t=this._minValue||0
}
if(this._minValue!=null&&t<this._minValue){
t=this._minValue
}
if(this._maxValue!=null&&t>this._maxValue){
t=this._maxValue
}
t=parseFloat(t);
if(this._decimals!=null){
t=t.toFixed(this._decimals)
}
this._lastValidValue=t;
return t
};
DwtSpinner.prototype.getInputElement=function(){
return document.getElementById(this._idField)
};
DwtSpinner.prototype._getUpButton=function(){
return document.getElementById(this._idUpButton)
};
DwtSpinner.prototype._getDownButton=function(){
return document.getElementById(this._idDownButton)
};
DwtSpinner.prototype._getButton=function(e){
switch(e){
case"Up":return this._getUpButton();
case"Down":return this._getDownButton()
}};
DwtSpinner.prototype._setBtnState=function(e,a){
var t=this._getButton(e);
if(a){
Dwt.addClass(t,"DwtSpinner-"+e+"-disabled");
t.firstChild.className="Img"+e+"ArrowSmallDis"
}else{
Dwt.delClass(t,"DwtSpinner-"+e+"-disabled");
t.firstChild.className="Img"+e+"ArrowSmall"
}};
DwtSpinner.prototype.getValue=function(){
return parseFloat(this._getValidValue(this.getInputElement().value))
};
DwtSpinner.prototype.setValue=function(e){
if(e==null){
e=this.getInputElement().value
}
e=this._getValidValue(e);
this.getInputElement().value=e;
e=parseFloat(e);
this._setBtnState("Down",this._minValue!=null&&this._minValue==e);
this._setBtnState("Up",this._maxValue!=null&&this._maxValue==e)
};
DwtSpinner.prototype.setEnabled=function(e){
DwtControl.prototype.setEnabled.call(this,e);
this.getInputElement().disabled=!e;
var t=this.getHtmlElement().firstChild;
if(!e){
Dwt.addClass(t,"DwtSpinner-disabled")
}else{
Dwt.delClass(t,"DwtSpinner-disabled")
}};
DwtSpinner.prototype._rotateVal=function(e){
var t=this.getValue();
switch(e){
case"Up":t+=this._step;
break;
case"Down":t-=this._step;
break
}
this.setValue(t)
};
DwtSpinner.prototype._btnPressed=function(e){
if(!this.getEnabled()){
return
}
Dwt.addClass(this._getButton(e),"DwtSpinner-"+e+"-pressed");
this._direction=e;
this._rotateVal(e);
this._btnPressCapture.capture();
this._timerSteps=0;
this._timer=setTimeout(this._timerFunc,DwtSpinner.INIT_TIMER)
};
DwtSpinner.prototype._timerFunc=function(){
var a=this.getValue();
this._rotateVal(this._direction);
var t=this.getValue();
this._timerSteps++;
var e=this._timerSteps>4?DwtSpinner.FAST_TIMER:DwtSpinner.SLOW_TIMER;
if(a!=t){
this._timer=setTimeout(this._timerFunc,e)
}else{
this._stopCapture()
}};
DwtSpinner.prototype._stopCapture=function(){
if(this._timer){
clearTimeout(this._timer)
}
this._timer=null;
this._timerSteps=null;
var t=this._direction;
Dwt.delClass(this._getButton(t),"DwtSpinner-"+t+"-pressed");
this._direction=null;
this._btnPressCapture.release();
var e=this.getInputElement();
e.focus();
Dwt.setSelectionRange(e,0,e.value.length)
};
DwtSpinner.prototype.__onKeyPress=function(a){
if(AjxEnv.isIE){
a=window.event
}
var t=null;
switch(a.keyCode){
case 38:t="Up";
break;
case 40:t="Down";
break
}
if(t){
this._rotateVal(t);
var e=this.getInputElement();
Dwt.setSelectionRange(e,0,e.value.length)
}};
DwtSpinner.prototype.focus=function(){
this.getInputElement().focus()
};
DwtSpinner.prototype.select=function(){
var e=this.getInputElement();
e.focus();
Dwt.setSelectionRange(e,0,e.value.length)
}
}
if(AjxPackage.define("ajax.util.AjxDlgUtil")){
AjxDlgUtil={
cache:{}
,getDialogLayout:function(i,a,r){
var s=new Date().getTime();
var e,t=AjxDlgUtil.cache;
if(t[i]){
e=t[i]
}else{
var o=AjxRpc.invoke(null,a+"?v="+s,null,null,true,5000);
t[i]=e=o.text
}
var n={};
e=e.replace(/<!--.*?-->/,"");
e=e.replace(/\$([a-zA-Z0-9_.]+)/g,function(d,c){
if(/^([^.]+)\.(.*)$/.test(c)){
var l=RegExp.$1;
var h=RegExp.$2;
switch(l){
case"id":var u=n[h];
if(!u){
u=n[h]=Dwt.getNextId()
}
return u;
case"msg":return r[h]
}}
return d
}
);
return{
ids:n,html:e}
}}
}
if(AjxPackage.define("zimbraMail.core.ZmClientCmdHandler")){
ZmClientCmdHandler=function(){
this._settings={};
this._dbg=window.DBG
};
ZmClientCmdHandler.prototype.execute=function(n,i){
if(!n){
return
}
n=AjxStringUtil.trim(n,true);
if(n==""){
return
}
var e=n.split(/\s/);
var a=e[0];
if(a!="modify"){
n=n.toLowerCase()
}
var o=this["execute_"+a];
if(o){
var t=[].concat(n,i,e);
return o.apply(this,t)
}};
ZmClientCmdHandler.prototype._alert=function(e,t){
appCtxt.setStatusMsg(e,t)
};
ZmClientCmdHandler.prototype.execute_debug=function(n,i,a,t){
if(!t||!this._dbg){
return
}
if(t=="t"){
var e=this._dbg._showTiming;
var o=e?"off":"on";
this._alert("Turning timing info "+o);
this._dbg.showTiming(!e)
}else{
this._dbg.setDebugLevel(t);
this._alert("Setting debug level to: "+t)
}};
ZmClientCmdHandler.prototype.execute_debugtrace=function(o,a,t,e){
if(!e){
return
}
var i;
if(e=="on"){
i=true
}else{
if(e=="off"){
i=false
}}
if(i!=undefined){
appCtxt.set(ZmSetting.OFFLINE_DEBUG_TRACE,i,null,null,true);
this._alert("Debug trace is "+e)
}};
ZmClientCmdHandler.prototype.execute_support=function(cmdStr,searchController,cmdName,cmdArg1){
if(!cmdArg1){
return
}
var feature=cmdArg1.toUpperCase();
var setting="ZmSetting."+feature+"_ENABLED";
var id=eval(setting);
var on=appCtxt.get(id);
if(on==undefined){
this._alert("No such setting: "+setting);
return
}
var newState=on?"off":"on";
alert("Turning "+feature+" support "+newState);
this._settings[id]=!on;
appCtxt.getAppController().restart(this._settings)
};
ZmClientCmdHandler.prototype.execute_instant_notify=function(o,i,a,t){
if(typeof t=="undefined"){
this._alert("Instant notify is "+(appCtxt.getAppController().getInstantNotify()?"ON":"OFF"))
}else{
var e=t&&(t.toLowerCase()=="on");
this._alert("Set instant notify to "+(e?"ON":"OFF"));
appCtxt.getAppController().setInstantNotify(e)
}};
ZmClientCmdHandler.prototype.execute_poll=function(o,a,t,e){
if(!e){
return
}
appCtxt.set(ZmSetting.POLLING_INTERVAL,e);
var i=appCtxt.get(ZmSetting.POLLING_INTERVAL);
if(appCtxt.getAppController().setPollInterval(true)){
this._alert("Set polling interval to "+i+" seconds")
}else{
this._alert("Ignoring polling interval b/c we are in Instant_Polling mode ($set:instant_notify 0|1)")
}};
ZmClientCmdHandler.prototype.execute_noop=function(i,a,t,e){
appCtxt.getAppController().sendNoOp();
this._alert("Sent NoOpRequest")
};
ZmClientCmdHandler.prototype.execute_a=function(i,a,t,e){
if(!this._assistantDialog){
AjxDispatcher.require("Assistant");
this._assistantDialog=new ZmAssistantDialog()
}
a.setSearchField("");
this._assistantDialog.popup()
};
ZmClientCmdHandler.prototype.execute_rr=function(i,a,t,e){
appCtxt.getApp(ZmApp.CALENDAR).getReminderController().refresh()
};
ZmClientCmdHandler.prototype.execute_rh=function(i,a,t,e){
appCtxt.getApp(ZmApp.CALENDAR).getReminderController()._housekeepingAction()
};
ZmClientCmdHandler.prototype.execute_toast=function(i,a,t,e){
appCtxt.setStatusMsg("Your options have been saved.",ZmStatusView.LEVEL_INFO);
appCtxt.setStatusMsg("Unable to save options.",ZmStatusView.LEVEL_WARNING);
appCtxt.setStatusMsg("Message not sent.",ZmStatusView.LEVEL_CRITICAL)
};
ZmClientCmdHandler.prototype.execute_get=function(i,a,t,e){
if(e&&e=="version"){
alert("Client Information\n\nClient Version: "+appCtxt.get(ZmSetting.CLIENT_VERSION)+"\nClient Release: "+appCtxt.get(ZmSetting.CLIENT_RELEASE)+"\n    Build Date: "+appCtxt.get(ZmSetting.CLIENT_DATETIME))
}};
ZmClientCmdHandler.prototype.execute_expire=function(i,a,t,e){
ZmCsfeCommand.clearSessionId();
this._alert("Session expired")
};
ZmClientCmdHandler.prototype.execute_refresh=function(i,a,t,e){
ZmCsfeCommand.clearSessionId();
appCtxt.getAppController().sendNoOp()
};
ZmClientCmdHandler.prototype.execute_relogin=function(o,i,a,t,e){
ZmCsfeCommand.clearAuthToken();
appCtxt.getAppController().sendNoOp()
};
ZmClientCmdHandler.prototype.execute_alert=function(n,o,i,a,t){
function e(){
if(a=="browser"){
AjxDispatcher.require("Alert");
ZmBrowserAlert.getInstance().start("Alert Test!")
}else{
if(a=="desktop"){
AjxDispatcher.require("Alert");
ZmDesktopAlert.getInstance().start("Title!","Message!")
}else{
if(a=="app"){
appCtxt.getApp(ZmApp.MAIL).startAlert()
}else{
AjxDispatcher.require("Alert");
ZmSoundAlert.getInstance().start()
}}}}
setTimeout(e,Number(t)*1000)
};
ZmClientCmdHandler.prototype.execute_leak=function(o,a,t,e){
if(!window.AjxLeakDetector){
this._alert("AjxLeakDetector is not loaded",ZmStatusView.LEVEL_WARNING)
}else{
var i=AjxLeakDetector.execute(e);
this._alert(i.message,i.success?ZmStatusView.LEVEL_INFO:ZmStatusView.LEVEL_WARNING)
}};
ZmClientCmdHandler.prototype.execute_tabs=function(i,a,t,e){
appCtxt.getRootTabGroup().dump(AjxDebug.DBG1)
};
ZmClientCmdHandler.prototype.execute_ymid=function(n,a,t,e){
var o=appCtxt.getSettings(),i=o.getSetting(ZmSetting.IM_YAHOO_ID);
i.setValue(e||"");
o.save([i]);
this._alert("Done")
};
ZmClientCmdHandler.prototype.execute_log=function(s,o,a,t,e){
var n=t;
if(e!=null){
var i=parseInt(e);
if(!isNaN(i)){
AjxDebug.BUFFER_MAX[n]=i;
this._alert("Debug log size for '"+n+"' set to "+i)
}}else{
appCtxt.getDebugLogDialog().popup(AjxDebug.getDebugLog(n),n)
}};
ZmClientCmdHandler.prototype.execute_compose=function(s,i,a,t){
var n=appCtxt.getApp(ZmApp.MAIL);
var e=(location.search.indexOf("mailto"));
if(e>=0){
var o="to="+decodeURIComponent(location.search.substring(e+7));
o=o.replace(/\?/g,"&");
n._showComposeView(null,o);
return true
}};
ZmClientCmdHandler.prototype.execute_error=function(n,o,i,a,e){
var t=appCtxt.getErrorDialog();
t.setMessage("Error Message!","Details!!",DwtMessageDialog.WARNING_STYLE);
t.popup()
};
ZmClientCmdHandler.prototype.execute_modify=function(n,e,r,o,i){
var a=appCtxt.getSettings();
var t=o&&a.getSettingByName(o);
if(t){
var h=a.getSetting(t);
h.setValue(i||h.getDefaultValue());
if(ZmSetting.IS_IMPLICIT[h.id]){
appCtxt.accountList.saveImplicitPrefs()
}else{
a.save([h])
}}
var s=appCtxt.getYesNoMsgDialog();
s.registerCallback(DwtDialog.YES_BUTTON,a._refreshBrowserCallback,a,[s]);
s.setMessage(ZmMsg.accountChangeRestart,DwtMessageDialog.WARNING_STYLE);
s.popup()
};
ZmClientCmdHandler.prototype.execute_clearAutocompleteCache=function(o,i,a,t,e){
appCtxt.clearAutocompleteCache(ZmAutocomplete.AC_TYPE_CONTACT);
this._alert("Contacts autocomplete cache cleared")
};
ZmClientCmdHandler.prototype.execute_getCharWidth=function(n,e,l,a,t){
var s=appCtxt.getApp(ZmApp.CONTACTS).getContactList().getArray();
for(var o=0;
o<s.length;
o++){
ZmClientCmdHandler._testWidth(s[o]._attrs.firstLast||s[o]._attrs.company||"")
}
var h=[];
h.push("Avg char width: "+ZmClientCmdHandler.WIDTH/ZmClientCmdHandler.CHARS);
h.push("Avg bold char width: "+ZmClientCmdHandler.BWIDTH/ZmClientCmdHandler.CHARS);
var r=ZmClientCmdHandler._testWidth(AjxStringUtil.ELLIPSIS);
h.push("Ellipsis width: "+r.w);
r=ZmClientCmdHandler._testWidth(", ");
h.push("Comma + space width: "+r.w);
alert(h.join("\n"))
};
ZmClientCmdHandler.CHARS=0;
ZmClientCmdHandler.WIDTH=0;
ZmClientCmdHandler.BWIDTH=0;
ZmClientCmdHandler._testWidth=function(i){
var o=document.createElement("DIV");
o.style.position=Dwt.ABSOLUTE_STYLE;
var e=appCtxt.getShell().getHtmlElement();
e.appendChild(o);
Dwt.setLocation(o,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
o.innerHTML=i;
var t=Dwt.getSize(o);
ZmClientCmdHandler.CHARS+=i.length;
ZmClientCmdHandler.WIDTH+=t.x;
o.style.fontWeight="bold";
var a=Dwt.getSize(o);
ZmClientCmdHandler.BWIDTH+=a.x;
e.removeChild(o);
return{
w:t.x,bw:a.x}
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmDialog")){
ZmDialog=function(e){
if(arguments.length==0){
return
}
DwtDialog.call(this,e);
if(!e.view){
this.setContent(this._contentHtml())
}
if(this._button[DwtDialog.OK_BUTTON]){
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._okButtonListener))
}
this._overview={};
this._opc=appCtxt.getOverviewController();
this._baseTabGroupSize=this._tabGroup.size()
};
ZmDialog.prototype=new DwtDialog;
ZmDialog.prototype.constructor=ZmDialog;
ZmDialog.prototype._contentHtml=function(){
return""
};
ZmDialog.prototype.setView=function(i,e){
this.reset();
if(i){
var a=this._getContentDiv();
var t=i.getHtmlElement();
a.parentNode.replaceChild(t,a);
this._contentDiv=t
}};
ZmDialog.prototype.popup=function(){
this._tabGroup.__members._array.splice(this._baseTabGroupSize);
this._tabGroup.addMember(this._getTabGroupMembers());
DwtDialog.prototype.popup.call(this);
if(this._focusElement){
appCtxt.getKeyboardMgr().grabFocus(this._focusElement)
}};
ZmDialog.prototype.reset=function(){
if(this._nameField){
this._nameField.value=""
}
DwtDialog.prototype.reset.call(this)
};
ZmDialog.prototype._okButtonListener=function(){
this.popdown()
};
ZmDialog.prototype._setNameField=function(e){
this._nameField=this._focusElement=document.getElementById(e);
if(this._enterListener){
this.addEnterListener(new AjxListener(this,this._enterListener))
}};
ZmDialog.prototype._setOverview=function(i,e){
if(appCtxt.multiAccounts){
var t=this._opc.getOverviewContainer(this._curOverviewId)||this._opc.getOverview(this._curOverviewId);
if(t){
t.setVisible(false)
}}
if(appCtxt.multiAccounts&&!e){
var s=this._curOverviewId=i.overviewId;
var h=this._opc.getOverviewContainer(s);
if(!h){
var r={
overviewClass:"dialogOverviewContainer",headerClass:"DwtTreeItem",noTooltips:true,treeStyle:i.treeStyle,treeIds:i.treeIds,overviewTrees:i.overviewTrees,omit:i.omit,omitPerAcct:i.omitPerAcct,selectable:i.selectable};
var o={
appName:i.appName,containerId:s};
h=this._opc.createOverviewContainer(o,r);
h.setSize(Dwt.DEFAULT,"200");
document.getElementById(i.fieldId).appendChild(h.getHtmlElement())
}
h.setVisible(true);
return h
}
var a=this._curOverviewId=i.overviewId;
var l=this._opc.getOverview(a);
if(!l){
var n={
overviewId:a,overviewClass:"dialogOverview",headerClass:"DwtTreeItem",noTooltips:true,treeStyle:i.treeStyle,treeIds:i.treeIds,account:((appCtxt.multiAccounts&&i.forceSingle)?appCtxt.getActiveAccount():(i.account||appCtxt.getActiveAccount()))};
l=this._overview[a]=this._opc.createOverview(n);
this._renderOverview(l,i.treeIds,i.omit,i.noRootSelect);
document.getElementById(i.fieldId).appendChild(l.getHtmlElement())
}
this._makeOverviewVisible(a);
return l
};
ZmDialog.prototype._makeOverviewVisible=function(e){
for(var t in this._overview){
this._overview[t].setVisible(t==e)
}};
ZmDialog.prototype._renderOverview=function(r,a,n,s){
r.set(a,n);
if(!s){
for(var o=0;
o<a.length;
o++){
var e=r.getTreeView(a[o]);
var t=e&&e.getHeaderItem();
if(t){
t.enableSelection(true)
}}}};
ZmDialog.prototype._getOverview=function(){
return this._overview[this._curOverviewId]
};
ZmDialog.prototype._getInputFields=function(){
return(this._nameField)?[this._nameField]:null
};
ZmDialog.prototype._showError=function(i,a){
var t=a||(new DwtPoint(this.getLocation().x+50,this.getLocation().y+100));
var e=appCtxt.getMsgDialog();
e.reset();
e.setMessage(AjxStringUtil.htmlEncode(i),DwtMessageDialog.CRITICAL_STYLE);
e.popup(t)
};
ZmDialog.prototype._getTabGroupMembers=function(){
return[this._nameField]
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmChooseFolderDialog")){
ZmChooseFolderDialog=function(a,t){
var e=new DwtDialog_ButtonDescriptor(ZmChooseFolderDialog.NEW_BUTTON,ZmMsg._new,DwtDialog.ALIGN_LEFT);
var i={
parent:a,className:t,extraButtons:[e],id:"ChooseFolderDialog"};
ZmDialog.call(this,i);
this._createControls();
this._setNameField(this._inputDivId);
this.registerCallback(ZmChooseFolderDialog.NEW_BUTTON,this._showNewDialog,this);
this._changeListener=new AjxListener(this,this._folderTreeChangeListener);
this._treeView={};
this._creatingFolder=false;
this._treeViewListener=new AjxListener(this,this._treeViewSelectionListener);
this._multiAcctOverviews={};
this._lastVal="";
this._selected=""
};
ZmChooseFolderDialog.prototype=new ZmDialog;
ZmChooseFolderDialog.prototype.constructor=ZmChooseFolderDialog;
ZmChooseFolderDialog.NEW_BUTTON=++DwtDialog.LAST_BUTTON;
ZmChooseFolderDialog.prototype.toString=function(){
return"ZmChooseFolderDialog"
};
ZmChooseFolderDialog.prototype.popup=function(c){
this._keyPressedInField=false;
c=c||{};
var y={};
var n=appCtxt.accountList.visibleAccounts;
for(var d=0;
d<n.length;
d++){
var p=n[d];
if(c.forceSingle&&p!=appCtxt.getActiveAccount()){
continue
}
var s=y[p.id]=c.omit||{};
s[ZmFolder.ID_DRAFTS]=!c.showDrafts;
s[ZmFolder.ID_OUTBOX]=true;
s[ZmFolder.ID_SYNC_FAILURES]=true;
var r=appCtxt.getFolderTree(p);
if(c.skipReadOnly||c.skipRemote||appCtxt.isOffline){
var h=r.asList({
includeRemote:true}
);
for(var d=0;
d<h.length;
d++){
var a=h[d];
if(c.skipReadOnly&&a.link&&a.isReadOnly()){
s[a.id]=true;
continue
}
if(c.skipRemote&&a.isRemote()){
s[h[d].id]=true
}}}}
this.setTitle(c.title||ZmMsg.chooseFolder);
var f=document.getElementById(this._folderDescDivId);
f.innerHTML=c.description||"";
var g=this._treeIds=(c.treeIds&&c.treeIds.length)?c.treeIds:[ZmOrganizer.FOLDER];
var t=(g.length==1&&g[0]==ZmOrganizer.SEARCH);
var u=this.getButton(ZmChooseFolderDialog.NEW_BUTTON);
u.setVisible(!t&&!c.hideNewButton);
this._data=c.data;
var o={};
if(appCtxt.multiAccounts){
o[ZmOrganizer.ID_ZIMLET]=true;
o[ZmOrganizer.ID_ALL_MAILBOXES]=true
}else{
o=y[appCtxt.accountList.mainAccount.id]
}
var e={
treeIds:g,omit:o,omitPerAcct:y,fieldId:this._folderTreeDivId,overviewId:c.overviewId,noRootSelect:c.noRootSelect,treeStyle:c.treeStyle||DwtTree.SINGLE_STYLE,appName:c.appName,selectable:false,forceSingle:c.forceSingle};
var l={};
for(var d=0;
d<g.length;
d++){
l[g[d]]=true
}
this._acceptFolderMatch=c.acceptFolderMatch;
var m=[];
if(l[ZmOrganizer.BRIEFCASE]){
m.push("BriefcaseCore","Briefcase")
}
if(l[ZmOrganizer.CALENDAR]){
m.push("CalendarCore","Calendar")
}
if(l[ZmOrganizer.ADDRBOOK]){
m.push("ContactsCore","Contacts")
}
if(l[ZmOrganizer.FOLDER]){
m.push("MailCore","Mail")
}
if(l[ZmOrganizer.NOTEBOOK]){
m.push("NotebookCore","Notebook")
}
if(l[ZmOrganizer.TASKS]){
m.push("TasksCore","Tasks")
}
AjxDispatcher.require(m,true,new AjxCallback(this,this._doPopup,[e]))
};
ZmChooseFolderDialog.prototype._doPopup=function(o){
var t=this._setOverview(o,o.forceSingle);
if(appCtxt.multiAccounts&&!o.forceSingle){
this._multiAcctOverviews[o.overviewId]=t;
for(var e in this._multiAcctOverviews){
this._multiAcctOverviews[e].setVisible(e==o.overviewId)
}
var n=t.getOverviews();
for(var e in n){
var a=n[e];
if(a._treeIds[0].toLowerCase()!="zimlet"){
this._resetTree(o.treeIds,a)
}}
t.expandAccountOnly(appCtxt.getActiveAccount())
}else{
this._resetTree(o.treeIds,t)
}
this._focusElement=this._inputField;
this._inputField.setValue("");
ZmDialog.prototype.popup.call(this)
};
ZmChooseFolderDialog.prototype.getOverviewId=function(e){
return appCtxt.getOverviewId([this.toString(),e],null)
};
ZmChooseFolderDialog.prototype._resetTree=function(l,c){
var r=c.account||appCtxt.getActiveAccount()||appCtxt.accountList.mainAccount;
var h=this._treeView[r.id]={};
var t=appCtxt.getFolderTree(r);
for(var n=0;
n<l.length;
n++){
var s=l[n];
var a=h[s]=c.getTreeView(s,true);
if(!a){
continue
}
a.getHeaderItem().setVisible(true,true);
var e=a.getTreeItemById(t.root.id);
e.setExpanded(true);
var o=ZmOrganizer.getSystemId(ZmOrganizer.ID_TRASH,r);
var e=a.getTreeItemById(o);
if(e){
e.setData(ZmTreeView.KEY_TYPE,s)
}
a.removeSelectionListener(this._treeViewListener);
a.addSelectionListener(this._treeViewListener)
}
t.removeChangeListener(this._changeListener);
t.addChangeListener(this._changeListener);
this._loadFolders();
this._resetTreeView(true)
};
ZmChooseFolderDialog.prototype.reset=function(){
var e=document.getElementById(this._folderDescDivId);
e.innerHTML="";
ZmDialog.prototype.reset.call(this);
this._data=this._treeIds=null;
this._creatingFolder=false
};
ZmChooseFolderDialog.prototype._contentHtml=function(){
this._inputDivId=this._htmlElId+"_inputDivId";
this._folderDescDivId=this._htmlElId+"_folderDescDivId";
this._folderTreeDivId=this._htmlElId+"_folderTreeDivId";
return AjxTemplate.expand("share.Widgets#ZmChooseFolderDialog",{
id:this._htmlElId}
)
};
ZmChooseFolderDialog.prototype._createControls=function(){
this._inputField=new DwtInputField({
parent:this}
);
document.getElementById(this._inputDivId).appendChild(this._inputField.getHtmlElement());
this._inputField.addListener(DwtEvent.ONKEYUP,new AjxListener(this,this._handleKeyUp));
this._inputField.setHandler(DwtEvent.ONKEYDOWN,AjxCallback.simpleClosure(this._handleKeyDown,this))
};
ZmChooseFolderDialog.prototype._showNewDialog=function(){
var a=this._getOverview().getSelected(true);
var e=(a&&a.type)||this._treeIds[0];
var i=this._opc.getTreeController(e);
var t=i._getNewDialog();
t.reset();
t.registerCallback(DwtDialog.OK_BUTTON,this._newCallback,this,[i,t]);
t.popup()
};
ZmChooseFolderDialog.prototype._newCallback=function(a,e,t){
a._doCreate(t);
e.popdown();
this._creatingFolder=true
};
ZmChooseFolderDialog.prototype._folderTreeChangeListener=function(a){
if(a.event==ZmEvent.E_CREATE&&this._creatingFolder){
var t=a.getDetail("organizers")||(a.source&&[a.source]);
var i=t[0];
var e=this._treeView[i.getAccount().id][i.type];
e.setSelected(t[0],true);
this._creatingFolder=false
}
this._loadFolders()
};
ZmChooseFolderDialog.prototype._okButtonListener=function(r){
var o=this._getOverview().getSelected();
if(!o){
o=appCtxt.getById(this._selected)
}
var t=(o&&(!(o instanceof Array)))?[o]:o;
var h=(!t||(t&&t.length==0))?ZmMsg.noTargetFolder:null;
if(!h&&this._data){
for(var a=0;
a<t.length;
a++){
var s=t[a];
if(s.mayContain&&!s.mayContain(this._data,null,this._acceptFolderMatch)){
if(this._data instanceof ZmFolder){
h=ZmMsg.badTargetFolder
}else{
var e=AjxUtil.toArray(this._data);
for(var a=0;
a<e.length;
a++){
var n=e[a];
if(!n){
continue
}
if(n.isDraft&&(s.nId!=ZmFolder.ID_TRASH&&s.nId!=ZmFolder.ID_DRAFTS&&s.rid!=ZmFolder.ID_DRAFTS)){
h=ZmMsg.badTargetFolderForDraftItem;
break
}else{
if((s.nId==ZmFolder.ID_DRAFTS||s.rid==ZmFolder.ID_DRAFTS)&&!n.isDraft){
h=ZmMsg.badItemForDraftsFolder;
break
}}}
if(!h){
h=ZmMsg.badTargetFolderItems
}}
break
}}}
if(h){
this._showError(h)
}else{
DwtDialog.prototype._buttonListener.call(this,r,[o])
}};
ZmChooseFolderDialog.prototype._getTabGroupMembers=function(){
return[this._inputField,this._overview[this._curOverviewId]]
};
ZmChooseFolderDialog.prototype._loadFolders=function(){
this._folders=[];
for(var h in this._treeView){
var n=this._treeView[h];
for(var c in n){
var o=n[c];
if(!o){
continue
}
var l=o.getTreeItemList();
for(var s=0,r=l.length;
s<r;
s++){
var t=l[s];
if(t.getData){
var a=l[s].getData(Dwt.KEY_OBJECT);
if(a&&(a.nId!=ZmOrganizer.ID_ROOT)){
var e=a.getName(false,null,true,true).toLowerCase();
var d="/"+a.getPath(false,false,null,true).toLowerCase();
this._folders.push({
id:a.id,type:c,name:e,path:d,accountId:h}
)
}}}}}};
ZmChooseFolderDialog.prototype._handleKeyDown=function(e){
this._keyPressedInField=true
};
ZmChooseFolderDialog.prototype._handleKeyUp=function(f){
if(!this._keyPressedInField){
return
}
var g=DwtKeyEvent.getCharCode(f);
if(g==9){
return
}else{
if(g==40){
this._overview[this._curOverviewId].focus();
return
}}
var l=0,b,r=[];
var p=this._inputField.getValue().toLowerCase();
if(p==this._lastVal){
return
}
for(var n=0,u=this._folders.length;
n<u;
n++){
var o=this._folders[n];
var a=this._treeView[o.accountId][o.type];
var e=a.getTreeItemById(o.id);
if(e){
var d="/"+p.replace(/^\//,"");
var y=o.path;
if(o.name.indexOf(p)==0||(y.indexOf(d)==0&&(y.substr(d.length).indexOf("/")==-1))){
r.push(e);
var m=appCtxt.getActiveAccount().id;
if(!b||(o.accountId==m&&b.accountId!=m)){
b=o
}}}}
this._resetTreeView(false);
for(var n=0,u=r.length;
n<u;
n++){
var e=r[n];
e._tree._expandUp(e);
e.setVisible(true)
}
if(b){
var c=this._treeView[b.accountId][b.type];
var t=this._getOverview();
if(t){
t._deselectAllTreeViews()
}
c.setSelected(appCtxt.getById(b.id),true,true);
this._selected=b.id;
if(appCtxt.multiAccounts){
var t=this._getOverview();
for(var s in t._headerItems){
t._headerItems[s].setExpanded((s==b.accountId),false,false)
}}}
this._lastVal=p
};
ZmChooseFolderDialog.prototype._resetTreeView=function(s){
for(var o=0,e=this._folders.length;
o<e;
o++){
var a=this._folders[o];
var t=this._treeView[a.accountId][a.type];
var n=t.getTreeItemById(a.id);
if(n){
n.setVisible(s);
n.setChecked(false,true)
}}};
ZmChooseFolderDialog.prototype._getOverview=function(){
var e;
if(appCtxt.multiAccounts){
e=this._opc.getOverviewContainer(this._curOverviewId)
}
return(e||ZmDialog.prototype._getOverview.call(this))
};
ZmChooseFolderDialog.prototype._treeViewSelectionListener=function(a){
if(a.detail!=DwtTree.ITEM_SELECTED&&a.detail!=DwtTree.ITEM_DBL_CLICKED){
return
}
if(this._getOverview() instanceof ZmAccountOverviewContainer){
if(a.detail==DwtTree.ITEM_DBL_CLICKED&&a.item instanceof DwtHeaderTreeItem){
return
}
var t=this._opc.getOverviewContainer(this._curOverviewId);
var o=t.getOverview(a.item.getData(ZmTreeView.KEY_ID));
t.deselectAll(o)
}
var e=a.item&&a.item.getData(Dwt.KEY_OBJECT);
var i=e?e.getName(null,null,true):a.item.getText();
this._inputField.setValue(i);
this._lastVal=i.toLowerCase();
if(a.detail==DwtTree.ITEM_DBL_CLICKED){
this._okButtonListener()
}};
ZmChooseFolderDialog.prototype._enterListener=function(e){
this._okButtonListener.call(this,e)
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmChooseAccountDialog")){
ZmChooseAccountDialog=function(e){
ZmDialog.call(this,{
parent:e}
);
this._createControls()
};
ZmChooseAccountDialog.prototype=new ZmDialog;
ZmChooseAccountDialog.prototype.constructor=ZmChooseAccountDialog;
ZmChooseAccountDialog.prototype.toString=function(){
return"ZmChooseAccountDialog"
};
ZmChooseAccountDialog.prototype.popup=function(u,a,h,l){
this.setTitle(l||ZmMsg.chooseAccount);
this._chooseMessageEl.innerHTML=h||ZmMsg.chooseAccount;
var t=u||appCtxt.getActiveAccount();
var e=appCtxt.accountList.visibleAccounts;
var n=[];
var d=0;
n[d++]="<table border=0 cellpadding=1 cellspacing=1>";
for(var o=0;
o<e.length;
o++){
var r=e[o];
if(appCtxt.isOffline&&r.isMain){
continue
}
if(a&&r.type!=a){
continue
}
var s=appCtxt.isOffline?r.getIcon():null;
var c=Dwt.getNextId();
n[d++]="<tr><td><input type='checkbox' name='";
n[d++]=this._inputName;
n[d++]="'";
if(r==t){
n[d++]=" checked"
}
n[d++]=" _acctId='";
n[d++]=r.id;
n[d++]="' id='";
n[d++]=c;
n[d++]="'></td>";
if(s){
n[d++]="<td>";
n[d++]=AjxImg.getImageHtml(s);
n[d++]="</td>"
}
n[d++]="<td><label for='";
n[d++]=c;
n[d++]="'>";
n[d++]=r.getDisplayName();
n[d++]="</label></td></tr>"
}
n[d++]="</table>";
this._accountSelectEl.innerHTML=n.join("");
ZmDialog.prototype.popup.call(this)
};
ZmChooseAccountDialog.prototype._okButtonListener=function(o){
var a=document.getElementsByName(this._inputName);
var e=[];
for(var t=0;
t<a.length;
t++){
if(a[t].checked){
e.push(a[t].getAttribute("_acctId"))
}}
DwtDialog.prototype._buttonListener.call(this,o,[e])
};
ZmChooseAccountDialog.prototype._enterListener=function(e){
this._okButtonListener.call(this,e)
};
ZmChooseAccountDialog.prototype._contentHtml=function(){
return AjxTemplate.expand("share.Widgets#ZmChooseAccountDialog",{
id:this._htmlElId}
)
};
ZmChooseAccountDialog.prototype._createControls=function(){
this._accountSelectEl=document.getElementById(this._htmlElId+"_accountSelectId");
this._chooseMessageEl=document.getElementById(this._htmlElId+"_chooseAccountMsg");
this._inputName=this._htmlElId+"_accountCheckbox"
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmDumpsterDialog")){
ZmDumpsterDialog=function(t,e){
var a={
parent:t,className:(e||"ZmDumpsterDialog"),title:ZmMsg.recoverDeletedItems,standardButtons:[DwtDialog.CANCEL_BUTTON]};
ZmDialog.call(this,a);
this.getButton(DwtDialog.CANCEL_BUTTON).setText(ZmMsg.close);
this._controller=new ZmDumpsterListController(this)
};
ZmDumpsterDialog.prototype=new ZmDialog;
ZmDumpsterDialog.prototype.constructor=ZmDumpsterDialog;
ZmDumpsterDialog.prototype.toString=function(){
return"ZmDumpsterDialog"
};
ZmDumpsterDialog.prototype.popup=function(e,t){
t=(t&&AjxUtil.toArray(t))||[ZmItem.MSG];
e=e||ZmId.SEARCH_ANY;
var a=t[0];
var i={
query:"is:anywhere",searchFor:e,types:t,sortBy:ZmSearch.DATE_DESC,noRender:true,inDumpster:true,callback:new AjxCallback(this._controller,this._controller.show,[t])};
this._controller.show(t,null);
appCtxt.getSearchController().search(i);
ZmDialog.prototype.popup.call(this)
};
ZmDumpsterDialog.prototype.popdown=function(){
ZmDialog.prototype.popdown.call(this);
this._controller.cleanup()
};
ZmDumpsterDialog.prototype._contentHtml=function(){
return AjxTemplate.expand("share.Widgets#ZmDumpsterDialog",{
id:this._htmlElId}
)
};
ZmDumpsterDialog.prototype._listSelectionListener=function(e){
var t=this._listview.getSelection()||[];
this._toolbar.enableAll((t.length>0))
};
ZmDumpsterListView=function(t,e){
if(!arguments.length){
return
}
this._controller=e;
var a={
parent:t,controller:e,pageless:true,view:this._getViewId(),headerList:this._getHeaderList(),type:this._getType(),parentElement:(t._htmlElId+"_listview")};
this._type=this._getType();
ZmListView.call(this,a);
this._listChangeListener=new AjxListener(this,this._changeListener)
};
ZmDumpsterListView.prototype=new ZmListView;
ZmDumpsterListView.prototype.constructor=ZmDumpsterListView;
ZmDumpsterListView.prototype.toString=function(){
return"ZmDumpsterListView"
};
ZmDumpsterListView.prototype._getViewId=function(){
var t=this._getType();
var e=ZmItem.APP[t];
return"dumpster"+e
};
ZmDumpsterListView.prototype._getCellId=function(e,t){
return this._getFieldId(e,t)
};
ZmDumpsterListView.prototype._getType=function(){
throw"ZmDumpsterListView.prototype._getType must be overridden by all inheriting classes"
};
ZmDumpsterListView.createView=function(t,a,e){
var i=t.replace(/^dumpster/,"");
switch(i){
case ZmApp.MAIL:return new ZmDumpsterMailListView(a,e);
case ZmApp.CONTACTS:return new ZmDumpsterContactListView(a,e);
case ZmApp.CALENDAR:return new ZmDumpsterCalendarListView(a,e);
case ZmApp.TASKS:return new ZmDumpsterTaskListView(a,e);
case ZmApp.BRIEFCASE:return new ZmDumpsterBriefcaseListView(a,e)
}};
ZmDumpsterMailListView=function(t,e){
ZmDumpsterListView.call(this,t,e)
};
ZmDumpsterMailListView.prototype=new ZmDumpsterListView;
ZmDumpsterMailListView.prototype.constructor=ZmDumpsterMailListView;
ZmDumpsterMailListView.prototype.toString=function(){
return"ZmDumpsterMailListView"
};
ZmDumpsterMailListView.prototype._getHeaderList=function(){
return[(new DwtListHeaderItem({
field:ZmItem.F_FROM,text:ZmMsg.from,width:ZmMsg.COLUMN_WIDTH_FROM_MLV}
)),(new DwtListHeaderItem({
field:ZmItem.F_SUBJECT,text:ZmMsg.subject}
)),(new DwtListHeaderItem({
field:ZmItem.F_DATE,text:ZmMsg.received,width:ZmMsg.COLUMN_WIDTH_DATE}
))]
};
ZmDumpsterMailListView.prototype._getType=function(){
return ZmItem.MSG
};
ZmDumpsterMailListView.prototype._getCellContents=function(h,r,l,s,i,a){
var o;
if(s==ZmItem.F_FROM){
var t=l.getAddress(AjxEmailAddress.FROM);
if(t){
o="<span style='white-space:nowrap'>";
var e=t.getName()||t.getDispName()||t.getAddress();
o+=AjxStringUtil.htmlEncode(e);
o+="</span>"
}}else{
if(s==ZmItem.F_SUBJECT){
var n=l.subject||ZmMsg.noSubject;
o=AjxStringUtil.htmlEncode(n)
}}
if(o){
h[r++]=o
}else{
r=ZmListView.prototype._getCellContents.apply(this,arguments)
}
return r
};
ZmDumpsterMailListView.prototype._getToolTip=function(e){
return e.item.getFragment()
};
ZmDumpsterContactListView=function(t,e){
ZmDumpsterListView.call(this,t,e)
};
ZmDumpsterContactListView.prototype=new ZmDumpsterListView;
ZmDumpsterContactListView.prototype.constructor=ZmDumpsterContactListView;
ZmDumpsterContactListView.prototype.toString=function(){
return"ZmDumpsterContactListView"
};
ZmDumpsterContactListView.prototype._getHeaderList=function(){
return[(new DwtListHeaderItem({
field:ZmItem.F_NAME,text:ZmMsg.name}
)),(new DwtListHeaderItem({
field:ZmItem.F_EMAIL,text:ZmMsg.email,width:200}
))]
};
ZmDumpsterContactListView.prototype._getType=function(){
return ZmItem.CONTACT
};
ZmDumpsterContactListView.prototype._getCellContents=function(r,s,h,n,a,t){
var i;
if(n==ZmItem.F_NAME){
var e=ZmContact.computeFileAs(h);
i=AjxStringUtil.htmlEncode(e)
}else{
if(n==ZmItem.F_EMAIL){
var o=h.getEmail();
i=o&&AjxStringUtil.htmlEncode(o)||"&nbsp;"
}}
if(i){
r[s++]=i
}else{
s=ZmListView.prototype._getCellContents.apply(this,arguments)
}
return s
};
ZmDumpsterCalendarListView=function(t,e){
ZmDumpsterListView.call(this,t,e)
};
ZmDumpsterCalendarListView.prototype=new ZmDumpsterListView;
ZmDumpsterCalendarListView.prototype.constructor=ZmDumpsterCalendarListView;
ZmDumpsterCalendarListView.prototype.toString=function(){
return"ZmDumpsterCalendarListView"
};
ZmDumpsterCalendarListView.prototype._getHeaderList=function(){
return[(new DwtListHeaderItem({
field:ZmItem.F_SUBJECT,text:ZmMsg.subject}
)),(new DwtListHeaderItem({
field:ZmItem.F_DATE,text:ZmMsg.date,width:ZmMsg.COLUMN_WIDTH_DATE_CAL}
))]
};
ZmDumpsterCalendarListView.prototype._getType=function(){
return ZmItem.APPT
};
ZmDumpsterCalendarListView.prototype._getCellContents=function(t,e,o,n,r,s){
var i;
if(n==ZmItem.F_SUBJECT){
var a=o.name;
i=AjxStringUtil.htmlEncode(a)
}else{
if(n==ZmItem.F_DATE){
i=o.startDate!=null?AjxDateUtil.simpleComputeDateStr(o.startDate):"&nbsp;"
}}
if(i){
t[e++]=i
}else{
e=ZmListView.prototype._getCellContents.apply(this,arguments)
}
return e
};
ZmDumpsterCalendarListView.prototype._getToolTip=function(e){
return e.item.fragment
};
ZmDumpsterTaskListView=function(t,e){
ZmDumpsterListView.call(this,t,e)
};
ZmDumpsterTaskListView.prototype=new ZmDumpsterListView;
ZmDumpsterTaskListView.prototype.constructor=ZmDumpsterTaskListView;
ZmDumpsterTaskListView.prototype.toString=function(){
return"ZmDumpsterTaskListView"
};
ZmDumpsterTaskListView.prototype._getHeaderList=function(){
return[(new DwtListHeaderItem({
field:ZmItem.F_SUBJECT,text:ZmMsg.subject}
)),(new DwtListHeaderItem({
field:ZmItem.F_STATUS,text:ZmMsg.status,width:ZmMsg.COLUMN_WIDTH_STATUS_TLV}
)),(new DwtListHeaderItem({
field:ZmItem.F_DATE,text:ZmMsg.date,width:ZmMsg.COLUMN_WIDTH_DATE_DUE_TLV}
))]
};
ZmDumpsterTaskListView.prototype._getType=function(){
return ZmItem.TASK
};
ZmDumpsterTaskListView.prototype._getCellContents=function(r,s,h,n,a,e){
var i;
if(n==ZmItem.F_SUBJECT){
var o=h.name;
i=AjxStringUtil.htmlEncode(o)
}else{
if(n==ZmItem.F_STATUS){
var t=h.status;
i=ZmCalItem.getLabelForStatus(h.status)
}else{
if(n==ZmItem.F_DATE){
i=h.endDate!=null?AjxDateUtil.simpleComputeDateStr(h.endDate):"&nbsp;"
}}}
if(i){
r[s++]=i
}else{
s=ZmListView.prototype._getCellContents.apply(this,arguments)
}
return s
};
ZmDumpsterTaskListView.prototype._getToolTip=function(e){
return e.item.fragment
};
ZmDumpsterBriefcaseListView=function(t,e){
ZmDumpsterListView.call(this,t,e)
};
ZmDumpsterBriefcaseListView.prototype=new ZmDumpsterListView;
ZmDumpsterBriefcaseListView.prototype.constructor=ZmDumpsterBriefcaseListView;
ZmDumpsterBriefcaseListView.prototype.toString=function(){
return"ZmDumpsterBriefcaseListView"
};
ZmDumpsterBriefcaseListView.prototype._getHeaderList=function(){
return[(new DwtListHeaderItem({
field:ZmItem.F_NAME,text:ZmMsg.name}
)),(new DwtListHeaderItem({
field:ZmItem.F_FILE_TYPE,text:ZmMsg.type,width:ZmMsg.COLUMN_WIDTH_TYPE_DLV}
)),(new DwtListHeaderItem({
field:ZmItem.F_SIZE,text:ZmMsg.size,width:ZmMsg.COLUMN_WIDTH_SIZE_DLV}
))]
};
ZmDumpsterBriefcaseListView.prototype._getType=function(){
return ZmItem.BRIEFCASE_ITEM
};
ZmDumpsterBriefcaseListView.prototype._getCellContents=function(r,s,h,n,a,t){
var i;
if(n==ZmItem.F_NAME){
var e=h.name;
i=AjxStringUtil.htmlEncode(e)
}else{
if(n==ZmItem.F_FILE_TYPE){
if(h.isFolder){
i=ZmMsg.folder
}else{
var o=h.contentType?ZmMimeTable.getInfo(h.contentType):null;
i=o?o.desc:"&nbsp;"
}}else{
if(n==ZmItem.F_SIZE){
var l=h.size;
i=AjxUtil.formatSize(l)
}}}
if(i){
r[s++]=i
}else{
s=ZmListView.prototype._getCellContents.apply(this,arguments)
}
return s
};
ZmDumpsterListController=function(e){
ZmListController.call(this,e,appCtxt.getApp(ZmApp.MAIL))
};
ZmDumpsterListController.prototype=new ZmListController;
ZmDumpsterListController.prototype.constructor=ZmDumpsterListController;
ZmDumpsterListController.prototype.toString=function(){
return"ZmDumpsterListController"
};
ZmDumpsterListController.prototype.show=function(a,t){
this._appName=ZmItem.APP[a[0]];
var e="dumpster"+this._appName;
for(var n in this._toolbar){
this._toolbar[n].setVisible(n==e)
}
for(var n in this._listView){
this._listView[n].setVisible(n==e)
}
if(t){
var i=t.getResponse();
ZmListController.prototype.show.call(this,i,e);
this._setup(e);
var o=i.getResults(i.type);
this.setList(o);
this.setHasMore(i.getAttribute("more"));
this.getCurrentView().set(o)
}else{
this.cleanup()
}};
ZmDumpsterListController.prototype.cleanup=function(){
var e=this.getCurrentView();
if(e){
e.removeAll()
}};
ZmDumpsterListController.prototype._getToolBarOps=function(){
return[ZmOperation.MOVE,ZmOperation.DELETE]
};
ZmDumpsterListController.prototype._createNewView=function(e){
return ZmDumpsterListView.createView(e,this._container,this)
};
ZmDumpsterListController.prototype._setViewContents=function(e){
this._listView[e].set(this._list)
};
ZmDumpsterListController.prototype._initializeToolBar=function(t){
if(this._toolbar[t]){
return
}
var i={
parent:this._container,className:"ZmDumpsterDialog-toolbar",buttons:this._getToolBarOps(),posStyle:Dwt.RELATIVE_STYLE,context:t,controller:this,parentElement:(this._container._htmlElId+"_toolbar")};
var e=this._toolbar[t]=new ZmButtonToolBar(i);
e.addSelectionListener(ZmOperation.MOVE,new AjxListener(this,this._moveListener));
e.addSelectionListener(ZmOperation.DELETE,new AjxListener(this,this._deleteListener));
var a=e.getButton(ZmOperation.MOVE);
a.setText(ZmMsg.recoverTo);
var a=e.getButton(ZmOperation.DELETE);
a.setToolTipContent(ZmMsg.permanentlyDelete)
};
ZmDumpsterListController.prototype._doMove=function(t,i,a,e){
if(!a){
a={}
}
a.op="recover";
a.l=i.id;
ZmListController.prototype._doMove.call(this,t,i,a,e)
};
ZmDumpsterListController.prototype._deleteListener=function(t){
var e=appCtxt.getOkCancelMsgDialog();
e.reset();
e.setMessage(ZmMsg.confirmItemDelete,DwtMessageDialog.WARNING_STYLE);
e.registerCallback(DwtDialog.OK_BUTTON,this._deleteCallback,this,[e]);
e.popup()
};
ZmDumpsterListController.prototype._deleteCallback=function(e){
e.popdown();
this._doDelete(this._listView[this._currentView].getSelection(),true,{
op:"dumpsterdelete"}
)
};
ZmDumpsterListController.prototype._getMoreSearchParams=function(e){
e.inDumpster=true
};
ZmDumpsterListController.prototype._getMoveParams=function(r){
var s=ZmListController.prototype._getMoveParams.call(this,r);
s.appName=this._appName;
s.overviewId=r.getOverviewId(this._appName);
s.treeIds=[ZmApp.ORGANIZER[this._appName]];
s.acceptFolderMatch=true;
s.showDrafts=true;
var n={};
n[ZmFolder.ID_SPAM]=true;
var o=appCtxt.getFolderTree();
if(!o){
return s
}
var t=o.getByType(ZmApp.ORGANIZER[this._appName]);
for(var e=0;
e<t.length;
e++){
var a=t[e];
if(a.link&&a.isRemote()){
n[a.id]=true
}}
s.omit=n;
return s
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmRenameFolderDialog")){
ZmRenameFolderDialog=function(t,e){
ZmDialog.call(this,{
parent:t,className:e,title:ZmMsg.renameFolder,id:"RenameFolderDialog"}
);
this._setNameField(this._nameFieldId)
};
ZmRenameFolderDialog.prototype=new ZmDialog;
ZmRenameFolderDialog.prototype.constructor=ZmRenameFolderDialog;
ZmRenameFolderDialog.prototype.toString=function(){
return"ZmRenameFolderDialog"
};
ZmRenameFolderDialog.prototype.popup=function(e,t){
ZmDialog.prototype.popup.call(this);
var a=(e.type==ZmOrganizer.SEARCH)?ZmMsg.renameSearch:ZmMsg.renameFolder;
this.setTitle(a+": "+e.getName(false,ZmOrganizer.MAX_DISPLAY_NAME_LENGTH));
this._nameField.value=e.getName(false,null,true);
this._folder=e
};
ZmRenameFolderDialog.prototype._contentHtml=function(){
this._nameFieldId=this._htmlElId+"_name";
var e={
id:this._htmlElId,newLabel:ZmMsg.newName};
return AjxTemplate.expand("share.Dialogs#ZmRenameDialog",e)
};
ZmRenameFolderDialog.prototype._okButtonListener=function(t){
var e=this._getFolderData();
if(e){
DwtDialog.prototype._buttonListener.call(this,t,e)
}};
ZmRenameFolderDialog.prototype._getFolderData=function(){
var e=AjxStringUtil.trim(this._nameField.value);
var a=ZmFolder.checkName(e,this._folder.parent);
if(!a){
var t=this._folder.parent.getByName(e);
if(t&&(t.id!=this._folder.id)){
a=ZmMsg.folderOrSearchNameExists
}}
return(a?this._showError(a):[this._folder,e])
};
ZmRenameFolderDialog.prototype._enterListener=function(t){
var e=this._getFolderData();
if(e){
this._runEnterCallback(e)
}}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmRenameTagDialog")){
ZmRenameTagDialog=function(t,e){
ZmDialog.call(this,{
parent:t,className:e,title:ZmMsg.renameTag,id:"RenameTagDialog"}
);
this._setNameField(this._nameFieldId)
};
ZmRenameTagDialog.prototype=new ZmDialog;
ZmRenameTagDialog.prototype.constructor=ZmRenameTagDialog;
ZmRenameTagDialog.prototype.toString=function(){
return"ZmRenameTagDialog"
};
ZmRenameTagDialog.prototype.popup=function(e,t){
ZmDialog.prototype.popup.call(this);
this.setTitle(ZmMsg.renameTag+": "+e.getName(false,ZmOrganizer.MAX_DISPLAY_NAME_LENGTH));
this._nameField.value=e.getName(false,null,true);
this._tag=e
};
ZmRenameTagDialog.prototype._contentHtml=function(){
this._nameFieldId=this._htmlElId+"_name";
var e={
id:this._htmlElId,newLabel:ZmMsg.newTagName};
return AjxTemplate.expand("share.Dialogs#ZmRenameDialog",e)
};
ZmRenameTagDialog.prototype._okButtonListener=function(t){
var e=this._getTagData();
if(e){
DwtDialog.prototype._buttonListener.call(this,t,e)
}};
ZmRenameTagDialog.prototype._getTagData=function(){
var a=AjxStringUtil.trim(this._nameField.value);
var o=ZmTag.checkName(a);
if(!o){
var e=appCtxt.getTagTree();
if(e){
var i=e.getByName(a);
if(i&&(i.id!=this._tag.id)){
o=ZmMsg.tagNameExists
}}}
return(o?this._showError(o):[this._tag,a])
};
ZmRenameTagDialog.prototype._enterListener=function(t){
var e=this._getTagData();
if(e){
this._runEnterCallback(e)
}}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmPasswordUpdateDialog")){
ZmPasswordUpdateDialog=function(t,e){
ZmDialog.call(this,{
parent:t,className:e,title:ZmMsg.changePassword,id:"PasswdChangeDialog"}
);
this._setNameField(this._nameFieldId);
this._createControls()
};
ZmPasswordUpdateDialog.prototype=new ZmDialog;
ZmPasswordUpdateDialog.prototype.constructor=ZmPasswordUpdateDialog;
ZmPasswordUpdateDialog.prototype.toString=function(){
return"ZmPasswordUpdateDialog"
};
ZmPasswordUpdateDialog.prototype.popup=function(a){
ZmDialog.prototype.popup.call(this);
this.acct=a;
var t=document.getElementById(this._htmlElId+"_desc");
this._toggleOKButton(false);
t.innerHTML=AjxMessageFormat.format(ZmMsg.offlinePasswordUpdate,this.acct.name);
var e=document.getElementById(this._htmlElId+"_acct");
e.innerHTML=this.acct.name;
this._nameField.value=""
};
ZmPasswordUpdateDialog.prototype._createControls=function(){
this.setTitle(ZmMsg.offlineAccountAuth);
this._toggleOKButton(false);
var t=this.getButton(DwtDialog.CANCEL_BUTTON);
t.setText(ZmMsg.dismiss);
var e=this.getButton(DwtDialog.OK_BUTTON);
e.setText(ZmMsg.save);
this._nameField._dlgEl=this._htmlElId;
Dwt.setHandler(this._nameField,DwtEvent.ONKEYUP,this._handleKeyUp)
};
ZmPasswordUpdateDialog.prototype._contentHtml=function(){
this._nameFieldId=this._htmlElId+"_name";
var e={
id:this._htmlElId,labelAcct:ZmMsg.account,labelPasswd:ZmMsg.password};
return AjxTemplate.expand("share.Dialogs#ZmPasswordUpdateDialog",e)
};
ZmPasswordUpdateDialog.prototype._okButtonListener=function(t){
var a=AjxStringUtil.trim(this._nameField.value);
if(a&&a.length>0){
var e=AjxSoapDoc.create("ChangePasswordRequest","urn:zimbraOffline");
e.setMethodAttribute("id",this.acct.id);
e.set("password",a);
appCtxt.getAppController().sendRequest({
soapDoc:e,asyncMode:true,noBusyOverlay:true,callback:new AjxCallback(this,this._handlePasswordUpdateResult),accountName:this.name}
)
}};
ZmPasswordUpdateDialog.prototype._handlePasswordUpdateResult=function(e){
var a=e.getResponse();
a=a.ChangePasswordResponse;
if(a&&a.status=="success"){
this.popdown();
var t=AjxMessageFormat.format(ZmMsg.offlinePasswordUpdateSuccess,this.acct.name);
appCtxt.setStatusMsg(t,ZmStatusView.LEVEL_INFO)
}else{
appCtxt.setStatusMsg(ZmMsg.offlinePasswordUpdateFailure,ZmStatusView.LEVEL_WARNING);
this._nameField.value="";
this._toggleOKButton(false)
}};
ZmPasswordUpdateDialog.prototype._enterListener=function(e){
var t=AjxStringUtil.trim(this._nameField.value);
if(t&&t.length>0){
this._okButtonListener()
}};
ZmPasswordUpdateDialog.prototype._handleKeyUp=function(i){
var t=DwtKeyEvent.getCharCode(i);
if(t==9){
return
}
var a=DwtUiEvent.getTarget(i);
var o=a&&a.value;
var e=a&&a._dlgEl&&DwtControl.ALL_BY_ID[a._dlgEl];
e._toggleOKButton(o.length>0)
};
ZmPasswordUpdateDialog.prototype._toggleOKButton=function(e){
var t=this.getButton(DwtDialog.OK_BUTTON);
t.setEnabled(e)
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmTwoFactorCodeUpdateDialog")){
ZmTwoFactorCodeUpdateDialog=function(e){
ZmDialog.call(this,{
parent:e,title:ZmMsg.changeTwoFactorCode,id:"TwoFactorCodeUpdateDialog"}
);
this._setNameField(this._nameFieldId);
this._createControls()
};
ZmTwoFactorCodeUpdateDialog.prototype=new ZmDialog;
ZmTwoFactorCodeUpdateDialog.prototype.constructor=ZmTwoFactorCodeUpdateDialog;
ZmTwoFactorCodeUpdateDialog.prototype.toString=function(){
return"ZmTwoFactorCodeUpdateDialog"
};
ZmTwoFactorCodeUpdateDialog.prototype.setMsgString=function(e){
this._msgText=e
};
ZmTwoFactorCodeUpdateDialog.prototype.popup=function(a){
ZmDialog.prototype.popup.call(this);
this.acct=a;
var t=document.getElementById(this._htmlElId+"_desc");
this._toggleOKButton(false);
t.innerHTML=AjxMessageFormat.format(this._msgText,this.acct.name);
var e=document.getElementById(this._htmlElId+"_acct");
e.innerHTML=this.acct.name;
this._nameField.value=""
};
ZmTwoFactorCodeUpdateDialog.prototype._createControls=function(){
this.setTitle(ZmMsg.offlineAccountAuth);
this._toggleOKButton(false);
var t=this.getButton(DwtDialog.CANCEL_BUTTON);
t.setText(ZmMsg.dismiss);
var e=this.getButton(DwtDialog.OK_BUTTON);
e.setText(ZmMsg.save);
this._nameField._dlgEl=this._htmlElId;
Dwt.setHandler(this._nameField,DwtEvent.ONKEYUP,this._handleKeyUp);
Dwt.setHandler(this._nameField,DwtEvent.ONPASTE,function(){
setTimeout(function(){
this._handleContextMenuPaste()
}
.bind(this),0)
}
.bind(this))
};
ZmTwoFactorCodeUpdateDialog.prototype._contentHtml=function(){
this._nameFieldId=this._htmlElId+"_name";
var e={
id:this._htmlElId,labelAcct:ZmMsg.account,labelTwoFactorCode:ZmMsg.code};
return AjxTemplate.expand("share.Dialogs#ZmTwoFactorCodeUpdateDialog",e)
};
ZmTwoFactorCodeUpdateDialog.prototype._okButtonListener=function(a){
var e=AjxStringUtil.trim(this._nameField.value);
if(e&&e.length>0){
var t=AjxSoapDoc.create("ResetTwoFactorCodeRequest","urn:zimbraOffline");
t.setMethodAttribute("id",this.acct.id);
t.set("twoFactorCode",e);
appCtxt.getAppController().sendRequest({
soapDoc:t,asyncMode:true,noBusyOverlay:true,callback:new AjxCallback(this,this._handleTwoFactorCodeUpdateResult),accountName:this.name}
)
}};
ZmTwoFactorCodeUpdateDialog.prototype._handleTwoFactorCodeUpdateResult=function(e){
var a=e.getResponse();
a=a.ResetTwoFactorCodeResponse;
if(a&&a.status=="success"){
this.popdown();
var t=AjxMessageFormat.format(ZmMsg.offlineTwoFactorCodeUpdateSuccess,this.acct.name);
appCtxt.setStatusMsg(t,ZmStatusView.LEVEL_INFO)
}else{
appCtxt.setStatusMsg(ZmMsg.offlineTwoFactorCodeUpdateFailure,ZmStatusView.LEVEL_WARNING);
this._nameField.value="";
this._toggleOKButton(false)
}};
ZmTwoFactorCodeUpdateDialog.prototype._enterListener=function(t){
var e=AjxStringUtil.trim(this._nameField.value);
if(e&&e.length>0){
this._okButtonListener()
}};
ZmTwoFactorCodeUpdateDialog.prototype._handleKeyUp=function(i){
var t=DwtKeyEvent.getCharCode(i);
if(t==9){
return
}
var a=DwtUiEvent.getTarget(i);
var o=a&&a.value;
var e=a&&a._dlgEl&&DwtControl.ALL_BY_ID[a._dlgEl];
e._toggleOKButton(o.length>0)
};
ZmTwoFactorCodeUpdateDialog.prototype._toggleOKButton=function(e){
var t=this.getButton(DwtDialog.OK_BUTTON);
t.setEnabled(e)
};
ZmTwoFactorCodeUpdateDialog.prototype._handleContextMenuPaste=function(){
var t=this._nameField;
var a=t.value;
var e=t&&t._dlgEl&&DwtControl.ALL_BY_ID[t._dlgEl];
e._toggleOKButton(a.length>0)
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmPickTagDialog")){
ZmPickTagDialog=function(a,t){
var e=new DwtDialog_ButtonDescriptor(ZmPickTagDialog.NEW_BUTTON,ZmMsg._new,DwtDialog.ALIGN_LEFT);
var i={
parent:a,className:t,title:ZmMsg.pickATag,extraButtons:[e]};
ZmDialog.call(this,i);
this._createControls();
this._setNameField(this._inputDivId);
this._tagTreeChangeListener=new AjxListener(this,this._handleTagTreeChange);
appCtxt.getTagTree().addChangeListener(this._tagTreeChangeListener);
this.registerCallback(ZmPickTagDialog.NEW_BUTTON,this._showNewDialog,this);
this._creatingTag=false;
this._treeViewListener=new AjxListener(this,this._treeViewSelectionListener);
this._lastVal=""
};
ZmPickTagDialog.prototype=new ZmDialog;
ZmPickTagDialog.prototype.constructor=ZmPickTagDialog;
ZmPickTagDialog.NEW_BUTTON=DwtDialog.LAST_BUTTON+1;
ZmPickTagDialog.prototype.toString=function(){
return"ZmPickTagDialog"
};
ZmPickTagDialog.prototype.popup=function(n){
n=n||{};
this._account=n.account;
if(appCtxt.multiAccounts&&n.account){
appCtxt.getTagTree().removeChangeListener(this._tagTreeChangeListener);
appCtxt.getTagTree(n.account).addChangeListener(this._tagTreeChangeListener)
}
var o=(appCtxt.multiAccounts&&n.account)?([this.toString(),"-",n.account.name].join("")):this.toString();
var a={
overviewId:o,treeIds:[ZmOrganizer.TAG],fieldId:this._tagTreeDivId,account:n.account};
this._setOverview(a,true);
this._tagTreeView=this._getOverview().getTreeView(ZmOrganizer.TAG);
this._tagTreeView.removeSelectionListener(this._treeViewListener);
this._tagTreeView.addSelectionListener(this._treeViewListener);
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
var t=this._tagTreeView.getTreeItemById(e);
if(t){
t.enableSelection(false)
}
this._loadTags();
this._resetTreeView();
this._focusElement=this._inputField;
this._inputField.setValue("");
var i=appCtxt.getTagTree(this._account).asList();
if(i.length==1){
this._tagTreeView.setSelected(i[0],true,true)
}
ZmDialog.prototype.popup.apply(this,arguments)
};
ZmPickTagDialog.prototype._contentHtml=function(){
this._tagTreeDivId=this._htmlElId+"_tagTreeDivId";
this._inputDivId=this._htmlElId+"_inputDivId";
return AjxTemplate.expand("share.Widgets#ZmPickTagDialog",{
id:this._htmlElId}
)
};
ZmPickTagDialog.prototype._createControls=function(){
this._inputField=new DwtInputField({
parent:this}
);
document.getElementById(this._inputDivId).appendChild(this._inputField.getHtmlElement());
this._inputField.addListener(DwtEvent.ONKEYUP,new AjxListener(this,this._handleKeyUp))
};
ZmPickTagDialog.prototype._showNewDialog=function(){
var e=appCtxt.getNewTagDialog();
e.reset();
e.registerCallback(DwtDialog.OK_BUTTON,this._newCallback,this);
e.popup(null,this._account)
};
ZmPickTagDialog.prototype._newCallback=function(t,e){
appCtxt.getNewTagDialog().popdown();
var a=this._opc.getTreeController(ZmOrganizer.TAG);
a._doCreate(t,e);
this._creatingTag=true
};
ZmPickTagDialog.prototype._loadTags=function(){
this._tags=[];
var a=this._tagTreeView.getTreeItemList();
for(var o=0,t=a.length;
o<t;
o++){
var e=a[o].getData(Dwt.KEY_OBJECT);
if(e.id!=ZmOrganizer.ID_ROOT){
this._tags.push({
id:e.id,name:e.getName(false,null,true,true).toLowerCase()}
)
}}};
ZmPickTagDialog.prototype._handleTagTreeChange=function(t){
if(t.event==ZmEvent.E_CREATE&&this._creatingTag){
var e=t.getDetail("organizers")[0];
this._tagTreeView.setSelected(e,true);
this._creatingTag=false
}
this._loadTags()
};
ZmPickTagDialog.prototype._okButtonListener=function(e){
DwtDialog.prototype._buttonListener.call(this,e,[this._tagTreeView.getSelected()])
};
ZmPickTagDialog.prototype._handleKeyUp=function(r){
var l=DwtKeyEvent.getCharCode(r);
if(l==9){
return
}else{
if(l==40){
this._overview[this._curOverviewId].focus();
return
}}
var n=0,c;
var h=this._inputField.getValue().toLowerCase();
if(h==this._lastVal){
return
}
for(var a=0,s=this._tags.length;
a<s;
a++){
var t=this._tags[a];
var e=this._tagTreeView.getTreeItemById(t.id);
if(e){
var o=(t.name.indexOf(h)==0);
e.setVisible(o);
if(o&&!c){
c=t.id
}}}
if(c){
this._tagTreeView.setSelected(appCtxt.getById(c),true,true)
}
this._lastVal=h
};
ZmPickTagDialog.prototype._resetTreeView=function(){
for(var t=0,e=this._tags.length;
t<e;
t++){
var a=this._tagTreeView.getTreeItemById(this._tags[t].id);
if(a){
a.setVisible(true)
}}
this._tagTreeView.getHeaderItem().setExpanded(true,false,true)
};
ZmPickTagDialog.prototype._treeViewSelectionListener=function(t){
if(t.detail!=DwtTree.ITEM_SELECTED&&t.detail!=DwtTree.ITEM_DBL_CLICKED){
return
}
var e=t.item.getData(Dwt.KEY_OBJECT);
if(e){
var a=e.getName(false,null,true,true);
this._lastVal=a.toLowerCase();
this._inputField.setValue(a);
if(t.detail==DwtTree.ITEM_DBL_CLICKED){
this._okButtonListener()
}}};
ZmPickTagDialog.prototype._getTabGroupMembers=function(){
return[this._inputField,this._overview[this._curOverviewId]]
};
ZmPickTagDialog.prototype._enterListener=function(e){
this._okButtonListener.call(this,e)
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmUploadDialog")){
ZmUploadDialog=function(e,t){
t=t||"ZmUploadDialog";
var a=ZmMsg.uploadDocs;
DwtDialog.call(this,{
parent:e,className:t,title:a}
);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._upload));
this._createUploadHtml();
this._showLinkTitleText=false;
this._linkText={}
};
ZmUploadDialog.prototype=new DwtDialog;
ZmUploadDialog.prototype.constructor=ZmUploadDialog;
ZmUploadDialog.ACTION_KEEP_MINE="mine";
ZmUploadDialog.ACTION_KEEP_THEIRS="theirs";
ZmUploadDialog.ACTION_ASK="ask";
ZmUploadDialog.UPLOAD_FIELD_NAME="uploadFile";
ZmUploadDialog.UPLOAD_TITLE_FIELD_NAME="uploadFileTitle";
ZmUploadDialog.prototype._selector;
ZmUploadDialog.prototype._uploadFolder;
ZmUploadDialog.prototype._uploadCallback;
ZmUploadDialog.prototype._extensions;
ZmUploadDialog.prototype.enableLinkTitleOption=function(e){
this._showLinkTitleText=e
};
ZmUploadDialog.prototype.setAllowedExtensions=function(t){
this._extensions=t;
if(t){
for(var e=0;
e<t.length;
e++){
t[e]=t[e].toUpperCase()
}}};
ZmUploadDialog.prototype.getNotes=function(){
return(this._notes?this._notes.value:"")
};
ZmUploadDialog.prototype.setNotes=function(e){
if(this._notes){
this._notes.value=(e||"")
}};
ZmUploadDialog.prototype.popup=function(a,d,c,r,f,n,i){
this._uploadFolder=a;
this._uploadCallback=d;
this._supportsHTML5=AjxEnv.supportsHTML5File&&!this._showLinkTitleText&&(appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)!=null);
this.setTitle(c||ZmMsg.uploadDocs);
var u=this._tableEl;
var m=u.rows;
while(m.length){
u.deleteRow(m.length-1)
}
this._addFileInputRow(f);
this.setButtonEnabled(DwtDialog.OK_BUTTON,true);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,true);
var t=this._htmlElId;
var e=document.getElementById(t+"_label");
if(e){
Dwt.setVisible(e,!f)
}
var l=document.getElementById(t+"_actionRow");
if(l){
Dwt.setVisible(l,!n)
}
var s=document.getElementById(t+"_notesTD");
if(s){
Dwt.setVisible(s,i)
}
var h=document.getElementById((t+"_info"));
if(h){
var o=AjxUtil.formatSize(appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)||0,true);
h.innerHTML=AjxMessageFormat.format(ZmMsg.attachmentLimitMsg,o)
}
DwtDialog.prototype.popup.call(this,r)
};
ZmUploadDialog.prototype.popdown=function(){
this._extensions=null;
this._enableStatus=false;
this._notes.removeAttribute("disabled");
this.setNotes("");
this._msgInfo.innerHTML="";
DwtDialog.prototype.popdown.call(this)
};
ZmUploadDialog.prototype.uploadFiles=function(a,o,t){
if(a.length==0){
return
}
this._uploadFolder=t;
var n=new AjxCallback(this,this._uploadSaveDocs,[a]);
var i=appCtxt.getUploadManager();
window._uploadManager=i;
try{
i.execute(n,o)
}
catch(e){
if(e.msg){
this._popupErrorDialog(e.msg)
}else{
this._popupErrorDialog(ZmMsg.unknownError)
}}};
ZmUploadDialog.prototype._upload=function(){
var e=this._uploadForm;
var o=[];
this._linkText={};
var l=e.elements;
var n=appCtxt.getActiveAccount().id;
if(e.action.length){
var s=e.action.indexOf("?")>0?"&limitAcct="+n:"limitAcct="+n;
e.action+=s
}
for(var u=0;
u<l.length;
u++){
var t=e.elements[u];
if(t.name!=ZmUploadDialog.UPLOAD_FIELD_NAME){
continue
}
if(!t.value){
continue
}
if(!this._checkExtension(t.value)){
var b=[this._extensions.join(", ")];
var r=AjxMessageFormat.format(ZmMsg.errorNotAllowedFile,b);
this._popupErrorDialog(r);
return
}
this._msgInfo.innerHTML="";
var h=this.getNotes();
if(this._supportsHTML5){
if(this._validateSize()){
var g=t.files;
for(var d=0;
d<g.length;
d++){
o.push({
name:g[d].name,fullname:g[d].name,notes:h}
)
}}else{
this._msgInfo.innerHTML=AjxMessageFormat.format(ZmMsg.attachmentSizeError,AjxUtil.formatSize(appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)));
return
}}else{
var w={
fullname:t.value,name:t.value.replace(/^.*[\\\/:]/,""),notes:h};
o.push(w)
}
if(this._showLinkTitleText){
var c=t.id;
c=c.replace("_input","")+"_titleinput";
var m=document.getElementById(c);
if(m){
this._linkText[w.name]=m.value
}}}
if(o.length==0){
return
}
this.setButtonEnabled(DwtDialog.OK_BUTTON,false);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,false);
var a=new AjxCallback(this,this._uploadSaveDocs,[o]);
var y=appCtxt.getUploadManager();
window._uploadManager=y;
try{
y.execute(a,this._uploadForm)
}
catch(p){
if(p.msg){
this._popupErrorDialog(p.msg)
}else{
this._popupErrorDialog(ZmMsg.unknownError)
}}};
ZmUploadDialog.prototype._checkExtension=function(e){
if(!this._extensions){
return true
}
var a=e.replace(/^.*\./,"").toUpperCase();
for(var t=0;
t<this._extensions.length;
t++){
if(this._extensions[t]==a){
return true
}}
return false
};
ZmUploadDialog.prototype._validateSize=function(){
var s=document.getElementsByName(ZmUploadDialog.UPLOAD_FIELD_NAME);
var o,a;
for(var t=0;
t<s.length;
t++){
o=s[t].files;
if(!o||o.length==0){
continue
}
for(var e=0;
e<o.length;
e++){
var n=o[e];
a=n.size||n.fileSize;
if(a>appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)){
return false
}}}
return true
};
ZmUploadDialog.prototype._popupErrorDialog=function(t){
this.setButtonEnabled(DwtDialog.OK_BUTTON,true);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,true);
var e=appCtxt.getMsgDialog();
e.setMessage(t,DwtMessageDialog.CRITICAL_STYLE,this._title);
e.popup()
};
ZmUploadDialog.prototype._uploadSaveDocs=function(o,e,n){
if(e!=AjxPost.SC_OK){
var a=AjxMessageFormat.format(ZmMsg.uploadError,e);
if(e=="413"){
a=ZmMsg.errorAttachmentTooBig
}
this._popupErrorDialog(a)
}else{
n=n.split(",");
for(var t=0;
t<o.length;
t++){
o[t].guid=n[t]
}
if(this._uploadFolder){
this._uploadSaveDocs2(o,e,n)
}else{
this._finishUpload(o,e,n)
}}};
ZmUploadDialog.prototype._uploadSaveDocs2=function(e,s,h){
var n=[];
var l=false;
for(var r=0;
r<e.length;
r++){
var a=e[r];
if(a.done){
continue
}
l=true;
var t={
_jsns:"urn:zimbraMail",requestId:r,doc:{}};
var c=t.doc;
if(a.id){
c.id=a.id;
c.ver=a.version
}else{
c.l=this._uploadFolder.id
}
if(a.notes){
c.desc=a.notes
}
c.upload={
id:a.guid};
n.push(t)
}
if(l){
var m={
BatchRequest:{
_jsns:"urn:zimbra",onerror:"continue",SaveDocumentRequest:((n.length==1)?n[0]:n)}};
var u=new AjxCallback(this,this._uploadSaveDocsResponse,[e,s,h]);
var o={
jsonObj:m,asyncMode:true,callback:u};
var d=appCtxt.getAppController();
d.sendRequest(o)
}};
ZmUploadDialog.prototype._uploadSaveDocsResponse=function(o,g,m,t){
var c=t&&t._data&&t._data.BatchResponse;
if(c&&c.SaveDocumentResponse){
for(var v=0;
v<c.SaveDocumentResponse.length;
v++){
var e=c.SaveDocumentResponse[v];
o[e.requestId].done=true;
o[e.requestId].name=e.doc[0].name;
o[e.requestId].id=e.doc[0].id;
o[e.requestId].ver=e.doc[0].ver;
o[e.requestId].version=e.doc[0].ver
}}
var h=[];
if(c&&c.Fault){
var s=[],l=false,r=false;
for(var v=0;
v<c.Fault.length;
v++){
var n=c.Fault[v];
var b=n.Detail.Error;
var a=b.Code;
var u=b.a;
r=(a==ZmCsfeException.LOCKED);
if(a==ZmCsfeException.MAIL_ALREADY_EXISTS||a==ZmCsfeException.MODIFY_CONFLICT){
var x=o[n.requestId];
for(var d in u){
var f=u[d];
switch(f.n){
case"itemId":x.id=f._content;
break;
case"id":x.id=f._content;
break;
case"ver":x.version=f._content;
break;
case"name":x.name=f._content;
break
}}
x.version=x.version||1;
h.push(x)
}else{
if(a==ZmCsfeException.MAIL_QUOTA_EXCEEDED){
l=true
}
s[n.requestId]=n
}}
if(l){
this._popupErrorDialog(ZmMsg.errorQuotaExceeded);
return
}else{
if(r){
this._popupErrorDialog(ZmMsg.errorItemLocked);
return
}else{
if(a==ZmCsfeException.SVC_PERM_DENIED){
this._popupErrorDialog(ZmMsg.errorPermissionDenied);
this.popdown();
return
}}}}
this.popdown();
var w=h.length;
var y=this._conflictAction||this._selector.getValue();
if(w>0&&y==ZmUploadDialog.ACTION_ASK){
var k=appCtxt.getUploadConflictDialog();
k.popup(this._uploadFolder,h,new AjxCallback(this,this._uploadSaveDocs2,[o,g,m]))
}else{
if(w>0&&y==ZmUploadDialog.ACTION_KEEP_MINE){
if(this._conflictAction){
this._shieldSaveDocs(o,g,m)
}else{
this._uploadSaveDocs2(o,g,m)
}}else{
if(this._uploadCallback){
this._finishUpload(o,g,m)
}else{
this._conflictAction=null
}}}};
ZmUploadDialog.prototype._shieldSaveDocs=function(t,e,a){
var i=appCtxt.getYesNoMsgDialog();
i.reset();
i.setButtonListener(DwtDialog.YES_BUTTON,new AjxListener(this,this._shieldSaveDocsYesCallback,[i,t,e,a]));
i.setMessage(ZmMsg.uploadConflictShield,DwtMessageDialog.WARNING_STYLE,ZmMsg.uploadConflict);
i.popup()
};
ZmUploadDialog.prototype._shieldSaveDocsYesCallback=function(i,t,e,a){
this._uploadSaveDocs2(t,e,a);
i.popdown()
};
ZmUploadDialog.prototype.setConflictAction=function(e){
this._conflictAction=e
};
ZmUploadDialog.prototype._finishUpload=function(n,e,s){
var o=[];
for(var a in n){
var t=n[a].name;
if(this._linkText[t]){
n[a].linkText=this._linkText[t]
}
o.push(t)
}
this._uploadCallback.run(this._uploadFolder,o,n);
this._conflictAction=null
};
ZmUploadDialog.prototype._addFileInputRow=function(f){
var e=Dwt.getNextId();
var h=e+"_input";
var i=e+"_remove";
var a=e+"_add";
var o=e+"_size";
var p=this._tableEl;
var g=p.insertRow(-1);
var m=g.insertCell(-1);
m.innerHTML=ZmMsg.fileLabel;
var d=g.insertCell(-1);
d.innerHTML=["<input id='",h,"' type='file' name='",ZmUploadDialog.UPLOAD_FIELD_NAME,"' size=30 ",(this._supportsHTML5?"multiple":""),">"].join("");
var d=g.insertCell(-1);
d.id=o;
d.innerHTML="&nbsp;";
if(this._supportsHTML5){
var c=document.getElementById(h);
var n=d;
Dwt.setHandler(c,"onchange",AjxCallback.simpleClosure(this._handleFileSize,this,c,n))
}
if(f){
d.colSpan=3
}else{
var d=g.insertCell(-1);
d.innerHTML=["<span ","id='",i,"' ","onmouseover='this.style.cursor=\"pointer\"' ","onmouseout='this.style.cursor=\"default\"' ","style='color:blue;text-decoration:underline;'",">",ZmMsg.remove,"</span>"].join("");
var r=document.getElementById(i);
Dwt.setHandler(r,DwtEvent.ONCLICK,ZmUploadDialog._removeHandler);
var d=g.insertCell(-1);
d.innerHTML="&nbsp;";
var d=g.insertCell(-1);
d.innerHTML=["<span ","id='",a,"' ","onmouseover='this.style.cursor=\"pointer\"' ","onmouseout='this.style.cursor=\"default\"' ","style='color:blue;text-decoration:underline;'",">",ZmMsg.add,"</span>"].join("");
var s=document.getElementById(a);
Dwt.setHandler(s,DwtEvent.ONCLICK,ZmUploadDialog._addHandler)
}
if(this._showLinkTitleText){
var t=e+"_titleinput";
var u=p.insertRow(-1);
var l=u.insertCell(-1);
l.innerHTML=[ZmMsg.linkTitleOptionalLabel].join("");
l=u.insertCell(-1);
l.innerHTML=["<input id='",t,"' type='text' name='",ZmUploadDialog.UPLOAD_TITLE_FIELD_NAME,"' size=40>"].join("");
l.colSpan=3
}};
ZmUploadDialog.prototype._handleFileSize=function(h,n){
var e=h.files;
if(!e){
return
}
var t=[],s,r=0;
for(var o=0;
o<e.length;
o++){
var a=e[o];
var l=a.size||a.fileSize;
if(l>appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)){
s="RedC"
}
r+=l
}
if(n){
n.innerHTML="  ("+AjxUtil.formatSize(r,true)+")";
if(s){
Dwt.addClass(n,"RedC")
}else{
Dwt.delClass(n,"RedC")
}}};
ZmUploadDialog._removeHandler=function(e){
var n=DwtUiEvent.getTarget(e||window.event);
var r=n.parentNode;
var l=r.parentNode;
var a=l;
if(n.id){
var t=n.id;
t=t.replace("_remove","")+"_titleinput";
var i=document.getElementById(t);
if(i){
var s=i.parentNode;
var h=s.parentNode;
a=h
}}
if(l.previousSibling==null&&a.nextSibling==null){
var o=DwtControl.findControl(n);
o._addFileInputRow()
}
if(a!=l){
a.parentNode.removeChild(a)
}
l.parentNode.removeChild(l)
};
ZmUploadDialog._addHandler=function(a){
var t=DwtUiEvent.getTarget(a||window.event);
var e=DwtControl.findControl(t);
e._addFileInputRow()
};
ZmUploadDialog.prototype._createUploadHtml=function(){
var o=this._htmlElId;
var a=appCtxt.get(ZmSetting.CSFE_UPLOAD_URI);
var t={
id:o,uri:a};
this.setContent(AjxTemplate.expand("share.Dialogs#UploadDialog",t));
this._uploadForm=document.getElementById((o+"_form"));
this._tableEl=document.getElementById((o+"_table"));
this._msgInfo=document.getElementById((o+"_msg"));
this._notes=document.getElementById((o+"_notes"));
this._selector=new DwtSelect({
parent:this}
);
this._selector.addOption(ZmMsg.uploadActionKeepMine,false,ZmUploadDialog.ACTION_KEEP_MINE);
this._selector.addOption(ZmMsg.uploadActionKeepTheirs,false,ZmUploadDialog.ACTION_KEEP_THEIRS);
this._selector.addOption(ZmMsg.uploadActionAsk,true,ZmUploadDialog.ACTION_ASK);
this._selector.reparentHtmlElement((o+"_conflict"));
var e=document.getElementById((o+"_info"));
if(e){
var i=AjxUtil.formatSize(appCtxt.get(ZmSetting.DOCUMENT_SIZE_LIMIT)||0,true);
e.innerHTML=AjxMessageFormat.format(ZmMsg.attachmentLimitMsg,i)
}}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmDebugLogDialog")){
ZmDebugLogDialog=function(e){
var t=ZmMsg.debugLog;
var i=new DwtDialog_ButtonDescriptor(ZmDebugLogDialog.EMAIL_BUTTON,ZmMsg.sendAsEmail,DwtDialog.ALIGN_LEFT);
var a=new DwtDialog_ButtonDescriptor(ZmDebugLogDialog.CLEAR_BUTTON,ZmMsg.clear,DwtDialog.ALIGN_LEFT);
DwtDialog.call(this,{
parent:e,title:t,standardButtons:[DwtDialog.OK_BUTTON],extraButtons:[i,a]}
);
this.setButtonListener(ZmDebugLogDialog.EMAIL_BUTTON,new AjxListener(this,this._handleEmailButton));
this.setButtonListener(ZmDebugLogDialog.CLEAR_BUTTON,new AjxListener(this,this._handleClearButton));
this._setAllowSelection();
this.setContent(this._contentHtml())
};
ZmDebugLogDialog.prototype=new DwtDialog;
ZmDebugLogDialog.prototype.constructor=ZmDebugLogDialog;
ZmDebugLogDialog.EMAIL_BUTTON="EMAIL";
ZmDebugLogDialog.CLEAR_BUTTON="CLEAR";
ZmDebugLogDialog.prototype.popup=function(a,t){
this._logType=t;
this.setTitle(AjxMessageFormat.format(ZmMsg.debugLog,[t]));
var i=document.getElementById(this._descDivId);
if(i){
var e=AjxDebug.BUFFER_MAX[t];
i.innerHTML=AjxMessageFormat.format(ZmMsg.debugLogDesc,[e,t])
}
i=document.getElementById(this._contentDivId);
if(i){
i.innerHTML=a
}
DwtDialog.prototype.popup.call(this)
};
ZmDebugLogDialog.prototype._contentHtml=function(){
this._descDivId=this._htmlElId+"_desc";
this._contentDivId=this._htmlElId+"_log";
return AjxTemplate.expand("share.Widgets#ZmDebugLogDialog",{
id:this._htmlElId}
)
};
ZmDebugLogDialog.prototype._handleEmailButton=function(e){
this.popdown();
var i=document.getElementById(this._contentDivId);
var a=AjxStringUtil.convertHtml2Text(i);
var t={
action:ZmOperation.NEW_MESSAGE,subjOverride:ZmMsg.debugLogEmailSubject,composeMode:DwtHtmlEditor.TEXT,extraBodyText:a};
appCtxt.getApp(ZmApp.MAIL).compose(t)
};
ZmDebugLogDialog.prototype._handleClearButton=function(e){
AjxDebug.BUFFER[this._logType]=[];
var t=document.getElementById(this._contentDivId);
t.innerHTML=""
}
}
if(AjxPackage.define("zimbraMail.share.view.htmlEditor.ZmTableEditor")){
ZmTableEditor={
RE_THICK_BORDERS:/^(double|groove|ridge|inset|outset)$/i,getTablePropsDialog:function(e,t){
if(!this._tablePropsDialog){
this._createTablePropsDialog()
}
this._updateTablePropsDialog(e,t);
return this._tablePropsDialog
}
,getCellPropsDialog:function(t,a,e){
if(!this._cellPropsDialog){
this._createCellPropsDialog()
}
this._updateCellPropsDialog(t,a,e);
return this._cellPropsDialog
}
,_createTablePropsDialog:function(){
this._tablePropsDialog=new ZmTablePropsDialog(DwtShell.getShell(window))
}
,_updateTablePropsDialog:function(e,t){
this._tablePropsDialog.setup(e,t)
}
,_createCellPropsDialog:function(){
this._cellPropsDialog=new ZmCellPropsDialog(DwtShell.getShell(window))
}
,_updateCellPropsDialog:function(t,a,e){
this._cellPropsDialog.setup(t,a,e)
}
,__makeCommonWidgets:function(){
var e={
parent:this,noFillLabel:ZmMsg.auto,parentElement:this._idBackgroundColor};
this._wBgColor=new DwtButtonColorPicker(e);
this._wBgColor.setImage("FontBackground");
this._wBgColor.showColorDisplay();
e.parentElement=this._idForegroundColor;
this._wFgColor=new DwtButtonColorPicker(e);
this._wFgColor.setImage("FontColor");
this._wFgColor.showColorDisplay();
e.parentElement=this._idBorderColor;
this._wBorderColor=new DwtButtonColorPicker(e);
this._wBorderColor.setImage("FontBorder");
this._wBorderColor.showColorDisplay();
this._wBorderStyle=new DwtSelect({
parent:this,options:[new DwtSelectOption("none",false,ZmMsg.none),new DwtSelectOption("solid",true,ZmMsg.borderStyleSolid),new DwtSelectOption("dashed",false,ZmMsg.borderStyleDashed),new DwtSelectOption("dotted",false,ZmMsg.borderStyleDotted),new DwtSelectOption("double",false,ZmMsg.borderStyleDouble),new DwtSelectOption("groove",false,ZmMsg.borderStyleGroove),new DwtSelectOption("ridge",false,ZmMsg.borderStyleRidge),new DwtSelectOption("inset",false,ZmMsg.borderStyleInset),new DwtSelectOption("outset",false,ZmMsg.borderStyleOutset)],parentElement:this._idBorderStyle}
);
this._wBorderStyle.addChangeListener(new AjxListener(this,ZmTableEditor.__onBorderStyleChange));
this._wBorderWidth=new DwtSpinner({
parent:this,size:3,min:0,max:10,parentElement:this._idBorderWidth}
);
this._wTextAlign=new DwtSelect({
parent:this,options:[new DwtSelectOption("",true,ZmMsg.notSet),new DwtSelectOption("left",false,ZmMsg.left),new DwtSelectOption("center",false,ZmMsg.center),new DwtSelectOption("right",false,ZmMsg.right)],parentElement:this._idTextAlign}
);
this._wTextVAlign=new DwtSelect({
parent:this,options:[new DwtSelectOption("",false,ZmMsg.notSet),new DwtSelectOption("top",false,ZmMsg.top),new DwtSelectOption("middle",true,ZmMsg.middle),new DwtSelectOption("bottom",false,ZmMsg.bottom)],parentElement:this._idTextVAlign}
);
this._wWidth=new DwtSpinner({
parent:this,size:3,min:0,parentElement:this._idWidth}
)
}
,__onBorderStyleChange:function(a){
var i=a._args;
var t=i.newValue;
if(ZmTableEditor.RE_THICK_BORDERS.test(t)){
var e=this._wBorderWidth.getValue();
if(e<3){
this._wBorderWidth.setValue(3)
}}}};
ZmTablePropsDialog=function(s){
if(arguments.length==0){
return
}
var t=new DwtDialog_ButtonDescriptor(ZmTablePropsDialog.ADVANCED_BUTTON,ZmMsg.advanced,DwtDialog.ALIGN_LEFT);
DwtDialog.call(this,{
parent:s,title:ZmMsg.tableProperties,standardButtons:[DwtDialog.OK_BUTTON,DwtDialog.CANCEL_BUTTON],extraButtons:[t]}
);
var e=Dwt.getNextId();
for(var n=ZmTablePropsDialog.IDS.length;
--n>=0;
){
var r=ZmTablePropsDialog.IDS[n];
this["_id"+r]=e+"_"+r
}
var o=AjxTemplate.expand("share.Dialogs#TableProperties",{
id:e}
);
this.setContent(o);
ZmTableEditor.__makeCommonWidgets.call(this);
this._wAlign=new DwtSelect({
parent:this,options:[new DwtSelectOption("",true,ZmMsg.notSet),new DwtSelectOption("center",false,ZmMsg.center),new DwtSelectOption("left",false,ZmMsg.left),new DwtSelectOption("right",false,ZmMsg.right)],parentElement:this._idAlign}
);
this._wCaption=new DwtInputField({
parent:this,type:DwtInputField.STRING,size:38,maxLen:255,validationStyle:DwtInputField.CONTINUAL_VALIDATION,parentElement:this._idCaption}
);
this._wCaption.getInputElement().style.width="100%";
this._wSummary=new DwtInputField({
parent:this,type:DwtInputField.STRING,size:38,maxLen:255,validationStyle:DwtInputField.CONTINUAL_VALIDATION,parentElement:this._idSummary}
);
this._wSummary.getInputElement().style.width="100%";
this._wWidthUnit=new DwtSelect({
parent:this,options:[new DwtSelectOption("%",false,ZmMsg.percent),new DwtSelectOption("px",true,ZmMsg.pixels)],parentElement:this._idWidthUnit}
);
this._wBorderSpacing=new DwtSpinner({
parent:this,size:3,min:0,max:10,parentElement:this._idBorderSpacing}
);
this._wCellPadding=new DwtSpinner({
parent:this,size:3,min:0,max:10,parentElement:this._idCellPadding}
);
var a=AjxCallback.simpleClosure(this._setManualWidthState,this);
document.getElementById(this._idWidthAuto).onclick=a;
document.getElementById(this._idWidthAuto1).onclick=a;
this.registerCallback(DwtDialog.OK_BUTTON,this._onOK,this);
this.registerCallback(DwtDialog.CANCEL_BUTTON,this._onCancel,this);
this.registerCallback(ZmTablePropsDialog.ADVANCED_BUTTON,this._onAdvanced,this)
};
ZmTablePropsDialog.prototype=new DwtDialog;
ZmTablePropsDialog.prototype.constructor=ZmTablePropsDialog;
ZmTablePropsDialog.ADVANCED_BUTTON=++DwtDialog.LAST_BUTTON;
ZmTablePropsDialog.IDS=["AdvancedMode1","AdvancedMode2","Align","BackgroundColor","BorderCollapse","BorderColor","BorderSpacing","BorderStyle","BorderWidth","Caption","CellPadding","FixedLayout","ForegroundColor","Summary","TextAlign","TextVAlign","Width","WidthAuto","WidthAuto1","WidthUnit"];
ZmTablePropsDialog.prototype.popup=function(){
DwtDialog.prototype.popup.call(this);
this._wCaption.focus()
};
ZmTablePropsDialog.prototype.popdown=function(){
this._cells=null;
this._table=null;
this._editor=null;
DwtDialog.prototype.popdown.call(this)
};
ZmTablePropsDialog.prototype.setup=function(l,f){
this._editor=l;
this._table=f;
var p=f.getElementsByTagName("caption");
p=p.length>0?p[0].innerHTML:"";
this._wCaption.setValue(p);
var d=f.summary||"";
this._wSummary.setValue(d);
var i=f.style.width||f.width;
document.getElementById(this._idWidthAuto).checked=!i;
document.getElementById(this._idWidthAuto1).checked=!!i;
if(i){
this._wWidthUnit.setSelected(/%/.test(i)?0:1);
i=parseInt(i);
this._wWidth.setValue(i)
}
this._setManualWidthState();
var r=f.style.tableLayout;
document.getElementById(this._idFixedLayout).checked=(r.toLowerCase()=="fixed");
var c=f.align;
switch(c){
case"center":c=1;
break;
case"left":c=2;
break;
case"right":c=3;
break;
default:c=0
}
this._wAlign.setSelected(c);
var o=f.style.textAlign;
switch(o){
case"left":o=1;
break;
case"center":o=2;
break;
case"right":o=3;
break;
default:o=0
}
this._wTextAlign.setSelected(o);
var h=f.style.verticalAlign;
switch(h){
case"top":h=1;
break;
case"middle":h=2;
break;
case"bottom":h=3;
break;
default:h=0
}
this._wTextVAlign.setSelected(h);
var t=f.style.color||"";
this._wFgColor.setColor(t);
var u=f.style.backgroundColor||"";
this._wBgColor.setColor(u);
var n=f.style.borderTopColor||"";
this._wBorderColor.setColor(n);
var e=f.style.borderTopWidth||0;
if(e){
e=parseInt(e);
this._wBorderWidth.setValue(e)
}else{
this._wBorderWidth.setValue("")
}
var g=f.style.borderTopStyle;
switch(g.toLowerCase()){
case"solid":g=1;
break;
case"dashed":g=2;
break;
case"dotted":g=3;
break;
case"double":g=4;
break;
case"groove":g=5;
break;
case"ridge":g=6;
break;
case"inset":g=7;
break;
case"outset":g=8;
break;
default:g=0
}
this._wBorderStyle.setSelected(g);
var a=f.cellSpacing;
this._wBorderSpacing.setValue(a);
var s=f.cellPadding;
this._wCellPadding.setValue(s);
var m=f.style.borderCollapse;
if(m){
document.getElementById(this._idBorderCollapse).checked=(m.toLowerCase().indexOf("collapse")!=-1)
}};
ZmTablePropsDialog.prototype._setManualWidthState=function(){
var e=document.getElementById(this._idWidthAuto).checked;
this._wWidth.setEnabled(!e);
this._wWidthUnit.setEnabled(!e)
};
ZmTablePropsDialog.prototype._onOK=function(){
this._editor.focus();
this._editor.applyTableProperties(this._table,this.getValues());
this.popdown()
};
ZmTablePropsDialog.prototype._onCancel=function(){
this._editor.focus();
this.popdown()
};
ZmTablePropsDialog.prototype._onAdvanced=function(){
this._advancedMode=!this._advancedMode;
var t=document.getElementById(this._idAdvancedMode1);
t.style.display=this._advancedMode?"":"none";
t=document.getElementById(this._idAdvancedMode2);
t.style.display=this._advancedMode?"":"none";
var e=this.getButton(ZmTablePropsDialog.ADVANCED_BUTTON);
e.setText(this._advancedMode?ZmMsg.simple:ZmMsg.advanced)
};
ZmTablePropsDialog.prototype.getValues=function(){
var e={
caption:this._wCaption.getValue(),summary:this._wSummary.getValue(),width:(document.getElementById(this._idWidthAuto).checked?"":this._wWidth.getValue()+this._wWidthUnit.getValue()),align:this._wAlign.getValue(),tableLayout:document.getElementById(this._idFixedLayout).checked?"fixed":"",textAlign:this._wTextAlign.getValue(),verticalAlign:this._wTextVAlign.getValue(),color:this._wFgColor.getColor(),backgroundColor:this._wBgColor.getColor(),borderWidth:this._wBorderWidth.getValue(),borderColor:this._wBorderColor.getColor(),borderStyle:this._wBorderStyle.getValue(),borderCollapse:document.getElementById(this._idBorderCollapse).checked?"collapse":"",cellPadding:this._wCellPadding.getValue(),cellSpacing:this._wBorderSpacing.getValue()};
if(e.borderWidth<3&&ZmTableEditor.RE_THICK_BORDERS.test(e.borderStyle)){
e.borderWidth=3
}
return e
};
ZmCellPropsDialog=function(d){
DwtDialog.call(this,d,null,ZmMsg.cellProperties,[DwtDialog.OK_BUTTON,DwtDialog.CANCEL_BUTTON]);
var s=Dwt.getNextId();
for(var h=ZmCellPropsDialog.IDS.length;
--h>=0;
){
var e=ZmCellPropsDialog.IDS[h];
this["_id"+e]=s+"_"+e
}
var l=AjxTemplate.expand("share.Dialogs#CellProperties",{
id:s}
);
this.setContent(l);
ZmTableEditor.__makeCommonWidgets.call(this);
this._wHeight=new DwtSpinner({
parent:this,size:3,min:0,parentElement:this._idHeight}
);
this._wHorizPadding=new DwtSpinner({
parent:this,size:3,min:0,max:10,parentElement:this._idHorizPadding}
);
this._wVertPadding=new DwtSpinner({
parent:this,size:3,min:0,max:10,parentElement:this._idVertPadding}
);
var u=document.getElementById(this._idQuickBorders);
var m=u.rows[0];
var o=m.cloneNode(true);
var n=0;
var c=new AjxListener(this,this._quickSetBorder);
for(var h=0;
h<ZmCellPropsDialog.QUICK_BORDERS.length;
++h){
var a=ZmCellPropsDialog.QUICK_BORDERS[h];
if(n==m.cells.length){
n=0;
m=o.cloneNode(true);
u.rows[0].parentNode.appendChild(m)
}
var r=m.cells[n];
n++;
var t=new DwtButton({
parent:this,className:"TBButton",parentElement:r}
);
t.setImage(a.img);
t.setData("ZmTableEditor",a);
t.addSelectionListener(c)
}
o=null;
var u=this.getPreviewGridHolder();
u.onmousemove=u.onmousedown=AjxCallback.simpleClosure(this._gridMouseEvent,this);
u.onmouseout=AjxCallback.simpleClosure(Dwt.delClass,Dwt,u,"Cursor-Pointer");
this.registerCallback(DwtDialog.OK_BUTTON,this._onOK,this);
this.registerCallback(DwtDialog.CANCEL_BUTTON,this._onCancel,this);
document.getElementById(this._idEnableWidth).onclick=AjxCallback.simpleClosure(this._enableWidget,this,this._wWidth,this._idEnableWidth);
document.getElementById(this._idEnableHeight).onclick=AjxCallback.simpleClosure(this._enableWidget,this,this._wHeight,this._idEnableHeight);
document.getElementById(this._idEnableHorizPadding).onclick=AjxCallback.simpleClosure(this._enableWidget,this,this._wHorizPadding,this._idEnableHorizPadding);
document.getElementById(this._idEnableVertPadding).onclick=AjxCallback.simpleClosure(this._enableWidget,this,this._wVertPadding,this._idEnableVertPadding);
document.getElementById(this._idEnableTextAlign).onclick=AjxCallback.simpleClosure(this._enableWidget,this,this._wTextAlign,this._idEnableTextAlign);
document.getElementById(this._idEnableTextVAlign).onclick=AjxCallback.simpleClosure(this._enableWidget,this,this._wTextVAlign,this._idEnableTextVAlign);
document.getElementById(this._idEnableBackgroundColor).onclick=AjxCallback.simpleClosure(this._enableWidget,this,this._wBgColor,this._idEnableBackgroundColor);
document.getElementById(this._idEnableForegroundColor).onclick=AjxCallback.simpleClosure(this._enableWidget,this,this._wFgColor,this._idEnableForegroundColor)
};
ZmCellPropsDialog.prototype=new DwtDialog;
ZmCellPropsDialog.prototype.constructor=ZmCellPropsDialog;
ZmCellPropsDialog.URL=appContextPath+"/js/zimbraMail/share/view/htmlEditor/dlg-cell-properties.html";
ZmCellPropsDialog.IDS=["BackgroundColor","BorderColor","BorderStyle","BorderWidth","EnableBackgroundColor","EnableForegroundColor","EnableHeight","EnableHorizPadding","EnableTextAlign","EnableTextVAlign","EnableVertPadding","EnableWidth","ForegroundColor","Height","HorizPadding","PreviewGrid","PreviewGridHolder","QuickBorders","TextAlign","TextVAlign","VertPadding","Width"];
ZmCellPropsDialog.QUICK_BORDERS=[{
img:"BorderAll",borders:[1,1,1,1,1,1]}
,{
img:"BorderBottom",borders:[0,0,1,0,0,0]}
,{
img:"BorderBottomDouble",style:"double",borders:[0,0,3,0,0,0]}
,{
img:"BorderBottomThick",borders:[0,0,2,0,0,0]}
,{
img:"BorderBox",borders:[1,0,1,1,0,1]}
,{
img:"BorderBoxDouble",style:"double",borders:[3,0,3,3,0,3]}
,{
img:"BorderBoxThick",borders:[2,0,2,2,0,2]}
,{
img:"BorderCenter",borders:[0,1,0,0,1,0]}
,{
img:"BorderH",borders:[0,1,0,0,0,0]}
,{
img:"BorderHEdges",borders:[1,0,1,0,0,0]}
,{
img:"BorderLeft",borders:[0,0,0,1,0,0]}
,{
img:"BorderNone",borders:[0,0,0,0,0,0]}
,{
img:"BorderRight",borders:[0,0,0,0,0,1]}
,{
img:"BorderTop",borders:[1,0,0,0,0,0]}
,{
img:"BorderTopBottomDouble",style:["solid","none","double","none","none","none"],borders:[1,0,3,0,0,0]}
,{
img:"BorderTopBottomThick",borders:[1,0,2,0,0,0]}
,{
img:"BorderTopDoubleBottomDouble",style:["double","none","double","none","none","none"],borders:[3,0,3,0,0,0]}
,{
img:"BorderTopThickBottomThick",borders:[2,0,2,0,0,0]}
,{
img:"BorderV",borders:[0,0,0,0,1,0]}
,{
img:"BorderVEdges",borders:[0,0,0,1,0,1]}
];
ZmCellPropsDialog.prototype._quickSetBorder=function(n){
var t=n.item;
var r=t.getData("ZmTableEditor");
var s=r.borders;
var o,a;
for(var e=s.length;
--e>=0;
){
o=s[e];
if(o){
if(r.style!=null){
a=(r.style instanceof Array)?r.style[e]:r.style
}else{
a="solid"
}}else{
continue
}
this._grid_applyBorderStyles(e,{
width:o+"px",style:a,color:this._wBorderColor.getColor()}
);
if(AjxEnv.isGeckoBased){
this._grid_refresh()
}}};
ZmCellPropsDialog.prototype.popdown=function(){
this._cells=null;
this._table=null;
this._editor=null;
DwtDialog.prototype.popdown.call(this)
};
ZmCellPropsDialog.prototype.getPreviewGridHolder=function(){
return document.getElementById(this._idPreviewGridHolder)
};
ZmCellPropsDialog.prototype.getPreviewGrid=function(){
return document.getElementById(this._idPreviewGrid)
};
ZmCellPropsDialog.prototype.setup=function(n,s,e){
var a=this.getPreviewGrid();
a.style.border="1px dashed #ccc";
var o=a.getElementsByTagName("td");
for(var t=0;
t<o.length;
++t){
o[t].style.border="1px dashed #ccc"
}
this._editor=n;
this._table=s;
this._cells=e;
this._wWidth.setEnabled(false);
this._wHeight.setEnabled(false);
this._wVertPadding.setEnabled(false);
this._wHorizPadding.setEnabled(false);
this._wTextAlign.setEnabled(false);
this._wTextVAlign.setEnabled(false);
this._wFgColor.setEnabled(false);
this._wBgColor.setEnabled(false);
document.getElementById(this._idEnableWidth).checked=false;
document.getElementById(this._idEnableHeight).checked=false;
document.getElementById(this._idEnableHorizPadding).checked=false;
document.getElementById(this._idEnableVertPadding).checked=false;
document.getElementById(this._idEnableTextAlign).checked=false;
document.getElementById(this._idEnableTextVAlign).checked=false;
document.getElementById(this._idEnableForegroundColor).checked=false;
document.getElementById(this._idEnableBackgroundColor).checked=false;
this._wBorderStyle.setSelected(1);
this._wBorderColor.setColor("#000000");
this._wBorderWidth.setValue(1);
this._grid_borderStyles=[null,null,null,null,null,null];
if(AjxEnv.isGeckoBased){
a.style.display="none";
setTimeout(function(){
a.style.display=""
}
,1)
}};
ZmCellPropsDialog.prototype._gridMouseEvent=function(s){
if(AjxEnv.isIE){
s=window.event
}
var a=DwtShell.mouseEvent;
a.setFromDhtmlEvent(s);
var r=this.getPreviewGridHolder();
var e=this.getPreviewGrid();
var t={
x:a.docX,y:a.docY};
var n=Dwt.getLocation(r);
var h=Dwt.getLocation(e);
var o=Dwt.getLocation(e.rows[1].cells[1].firstChild);
var c={
x:h.x+e.offsetWidth,y:h.y+e.offsetHeight};
var l=this._pickBestBorder(t.y,DwtHtmlEditor.BORDER_TOP,4,h.y+this._grid_getBorderWidth(DwtHtmlEditor.BORDER_TOP)/2,o.y-this._grid_getBorderWidth(DwtHtmlEditor.BORDER_MIDDLE)/2,c.y-this._grid_getBorderWidth(DwtHtmlEditor.BORDER_BOTTOM)/2);
var i=this._pickBestBorder(t.x,DwtHtmlEditor.BORDER_LEFT,4,h.x+this._grid_getBorderWidth(DwtHtmlEditor.BORDER_LEFT)/2,o.x-this._grid_getBorderWidth(DwtHtmlEditor.BORDER_CENTER)/2,c.x-this._grid_getBorderWidth(DwtHtmlEditor.BORDER_RIGHT)/2);
if(/mousedown/i.test(a.type)){
this._grid_applyBorderStyles(l);
this._grid_applyBorderStyles(i);
if((l!=null||i!=null)&&AjxEnv.isGeckoBased){
this._grid_refresh()
}}else{
if(l!=null||i!=null){
Dwt.addClass(r,"Cursor-Pointer")
}else{
Dwt.delClass(r,"Cursor-Pointer")
}}
a._stopPropagation=true;
a._returnValue=false;
a.setToDhtmlEvent(s);
return a._returnValue
};
ZmCellPropsDialog.prototype._grid_refresh=function(){
var e=this.getPreviewGrid();
e.style.display="none";
setTimeout(function(){
e.style.display=""
}
,1)
};
ZmCellPropsDialog.prototype._pickBestBorder=function(o,t,e,h,r,s){
var a=Math.abs(o-h);
var n=Math.abs(o-r);
var i=Math.abs(o-s);
if(a<e){
return t
}
if(n<e){
return t+1
}
if(i<e){
return t+2
}
return null
};
ZmCellPropsDialog.prototype._grid_getBorderWidth=function(e){
var t=this.getPreviewGrid();
switch(e){
case DwtHtmlEditor.BORDER_TOP:return parseInt(t.style.borderTopWidth);
case DwtHtmlEditor.BORDER_MIDDLE:return parseInt(t.rows[0].cells[0].style.borderBottomWidth);
case DwtHtmlEditor.BORDER_BOTTOM:return parseInt(t.style.borderBottomWidth);
case DwtHtmlEditor.BORDER_LEFT:return parseInt(t.style.borderLeftWidth);
case DwtHtmlEditor.BORDER_CENTER:return parseInt(t.rows[0].cells[0].style.borderRightWidth);
case DwtHtmlEditor.BORDER_RIGHT:return parseInt(t.style.borderRightWidth)
}};
ZmCellPropsDialog.prototype._grid_applyBorderStyles=function(l,a){
var c=[];
var e=this.getPreviewGrid();
switch(l){
case DwtHtmlEditor.BORDER_TOP:c.push({
el:e,b:"borderTop"}
,{
el:e.rows[0].cells[0],b:"borderTop"}
,{
el:e.rows[0].cells[1],b:"borderTop"}
);
break;
case DwtHtmlEditor.BORDER_MIDDLE:c.push({
el:e.rows[0].cells[0],b:"borderBottom"}
,{
el:e.rows[0].cells[1],b:"borderBottom"}
,{
el:e.rows[1].cells[0],b:"borderTop"}
,{
el:e.rows[1].cells[1],b:"borderTop"}
);
break;
case DwtHtmlEditor.BORDER_BOTTOM:c.push({
el:e,b:"borderBottom"}
,{
el:e.rows[1].cells[0],b:"borderBottom"}
,{
el:e.rows[1].cells[1],b:"borderBottom"}
);
break;
case DwtHtmlEditor.BORDER_LEFT:c.push({
el:e,b:"borderLeft"}
,{
el:e.rows[0].cells[0],b:"borderLeft"}
,{
el:e.rows[1].cells[0],b:"borderLeft"}
);
break;
case DwtHtmlEditor.BORDER_CENTER:c.push({
el:e.rows[0].cells[0],b:"borderRight"}
,{
el:e.rows[0].cells[1],b:"borderLeft"}
,{
el:e.rows[1].cells[0],b:"borderRight"}
,{
el:e.rows[1].cells[1],b:"borderLeft"}
);
break;
case DwtHtmlEditor.BORDER_RIGHT:c.push({
el:e,b:"borderRight"}
,{
el:e.rows[0].cells[1],b:"borderRight"}
,{
el:e.rows[1].cells[1],b:"borderRight"}
);
break
}
var n=this._wBorderWidth.getValue();
var t=this._wBorderStyle.getValue();
if(n<3&&ZmTableEditor.RE_THICK_BORDERS.test(t)){
this._wBorderWidth.setValue(3);
n=3
}
var m=this._grid_borderStyles[l];
var r=a||{
width:n+"px",color:this._wBorderColor.getColor(),style:t};
if(a||m==null||(m.width!=r.width||m.color!=r.color||m.style!=r.style)){
m=this._grid_borderStyles[l]=r
}else{
this._grid_borderStyles[l]=null;
m={
width:"1px",color:"#ccc",style:"dashed"}
}
for(var d=0;
d<c.length;
++d){
var h=c[d];
var u=h.b;
h=h.el;
h.style[u+"Width"]=m.width;
h.style[u+"Color"]=m.color;
h.style[u+"Style"]=m.style
}};
ZmCellPropsDialog.prototype.getValues=function(){
var e={
borders:this._grid_borderStyles,width:this._wWidth.getEnabled()?this._wWidth.getValue():null,height:this._wHeight.getEnabled()?this._wHeight.getValue():null,horizPadding:this._wHorizPadding.getEnabled()?this._wHorizPadding.getValue():null,vertPadding:this._wVertPadding.getEnabled()?this._wVertPadding.getValue():null,textAlign:this._wTextAlign.getEnabled()?this._wTextAlign.getValue():null,verticalAlign:this._wTextVAlign.getEnabled()?this._wTextVAlign.getValue():null,color:this._wFgColor.getEnabled()?this._wFgColor.getColor():null,backgroundColor:this._wBgColor.getEnabled()?this._wBgColor.getColor():null};
return e
};
ZmCellPropsDialog.prototype._onOK=function(){
this._editor.focus();
this._editor.applyCellProperties(this._table,this._cells,this.getValues());
this.popdown()
};
ZmCellPropsDialog.prototype._onCancel=function(){
this.popdown()
};
ZmCellPropsDialog.prototype._enableWidget=function(t,e){
e=document.getElementById(e);
t.setEnabled(e.checked);
if(e.checked){
if(typeof t.select=="function"){
t.select()
}else{
if(typeof t.focus=="function"){
t.focus()
}}}}
}
if(AjxPackage.define("zimbraMail.share.view.htmlEditor.ZmSpellChecker")){
ZmSpellChecker=function(e){
this._parent=e
};
ZmSpellChecker.prototype.toString=function(){
return"ZmSpellChecker"
};
ZmSpellChecker.prototype.check=function(e,o,t){
var i=typeof e=="string"?{
text:e}
:e;
var a=AjxSoapDoc.create("CheckSpellingRequest","urn:zimbraMail");
a.getMethod().appendChild(a.getDoc().createTextNode(i.text));
if(i.ignore){
a.getMethod().setAttribute("ignore",i.ignore)
}
var o=new AjxCallback(this,this._checkCallback,o);
appCtxt.getAppController().sendRequest({
soapDoc:a,asyncMode:true,callback:o,errorCallback:t}
)
};
ZmSpellChecker.prototype._checkCallback=function(a,e){
var t=e._isException?null:e.getResponse().CheckSpellingResponse;
if(a){
a.run(t)
}}
}};
