
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Leaks")){
if(AjxPackage.define("ajax.debug.AjxLeakDetector")){
AjxLeakDetector=function(){
this._controls=[];
this._closures={};
this._closureReport=[];
this._nextId=1;
this._addHooks()
};
AjxLeakDetector.execute=function(i){
var e={
success:false,message:"",details:""};
if(i=="begin"){
e.success=AjxLeakDetector.begin();
e.message=e.success?"Leak detector started.":"Leak detector already started."
}else{
if(i=="end"){
e.success=AjxLeakDetector.end();
e.message=e.success?"Leak detector stopped.":"Leak detector is not running."
}else{
if(i=="report"||i=="dispose"){
if(i=="dispose"){
var a=DwtShell.getShell(window);
a.dispose(true);
document.title="Shell has been disposed"
}
var t=[];
e.success=AjxLeakDetector.report(t);
if(t.length){}
if(e.success){
e.message=t.length?"Problems found. See debug window for details.":"No problems found"
}else{
e.message="Leak detector is not running."
}}else{
e.success=false;
e.message="Invalid argument, use (begin/end/report)"
}}}
return e
};
AjxLeakDetector.begin=function(){
if(!AjxLeakDetector._instance){
AjxLeakDetector._instance=new AjxLeakDetector();
return true
}else{
return false
}};
AjxLeakDetector.end=function(){
if(AjxLeakDetector._instance){
AjxLeakDetector._instance._removeHooks();
AjxLeakDetector._instance=null;
return true
}else{
return false
}};
AjxLeakDetector.report=function(e){
if(AjxLeakDetector._instance){
AjxLeakDetector._instance._createReport(e);
return true
}else{
return false
}};
AjxLeakDetector.prototype._addHooks=function(){
var t=this;
var e=DwtControl.prototype.__initCtrl;
DwtControl.prototype.__initCtrl=function(){
t._controls.push(this);
e.call(this)
};
var a=DwtControl.prototype.dispose;
DwtControl.prototype.dispose=function(){
var o=document.getElementById(this.getHTMLElId());
a.call(this);
t._postDisposeCheck(this,o)
};
var i=AjxCallback.simpleClosure;
AjxCallback.simpleClosure=function(h,l){
var o=i.apply(null,arguments);
o.__leakDetectorId=t._nextId++;
var n=[];
for(var s=0,r=arguments.length;
s<r;
s++){
n[s]=arguments[s]
}
t._closures[o.__leakDetectorId]={
closure:o,args:n};
return o
};
this._removeHooks=function(){
DwtControl.prototype.__initCtrl=e;
DwtControl.prototype.dispose=a;
AjxCallback.simpleClosure=i
}
};
AjxLeakDetector.prototype._createReport=function(e){
for(var o=0,n=this._controls.length;
o<n;
o++){
var r=this._controls[o];
if(!r._disposed){
var a=document.getElementById(r.getHTMLElId());
if(!a){
this._log(e,"Detached html element",r)
}}else{
var h=null;
for(var t in r){
var s=r[t];
if(s&&s.tagName){
h=h||[];
h.push(t)
}}
if(h){
this._log(e,"Elements referenced by control: "+h.join(", "),r)
}}}
for(var o=0,n=this._closureReport.length;
o<n;
o++){
e.push(this._closureReport[o])
}
if(e.length){
return e.join("")
}else{
return"Leak detector: no problems detected"
}};
AjxLeakDetector.prototype._log=function(e,o,s,a){
e.push(o);
e.push("\n ");
var n=[s];
while(s.parent){
n.push(s.parent);
s=s.parent
}
for(var t=n.length-1;
t>=0;
t--){
e.push(n[t].toString());
if(t>0){
e.push("->")
}}
this._logAttrs(e,n[0]);
e.push("\n------------------------\n")
};
AjxLeakDetector.prototype._logAttrs=function(t,h){
var e={
DwtLabel:["__text","__imageInfo"]};
var a=false;
for(var s in e){
if(Dwt.instanceOf(h,s)){
if(!a){
t.push("{\n")
}
var o=e[s];
for(var n=0,r=o.length;
n<r;
n++){
t.push(" ");
t.push(o[n]);
t.push(": ");
t.push(h[o[n]]);
t.push("\n")
}
a=true
}}
if(a){
t.push("}\n")
}};
AjxLeakDetector.prototype._postDisposeCheck=function(a,t){
var e=[];
if(!t){
this._log(this._closureReport,"Very bad: control's element not in DOM: "+e.join(""),a)
}else{
this._postDisposeElementCheck(e,t);
if(e.length){
this._log(this._closureReport,"Suspicioius closure args in control: "+e.join(""),a)
}}};
AjxLeakDetector.prototype._postDisposeElementCheck=function(n,h){
var o=null;
for(var t in h){
var c=null;
var m;
try{
m=h[t]
}
catch(d){}
if(m&&m.__leakDetectorId){
var r=this._closures[m.__leakDetectorId];
if(r){
var u=r.args;
for(var s=0,l=u.length;
s<l;
s++){
var f=u[s];
if(f instanceof DwtControl){
c=c||[];
c.push(f.toString())
}else{
if(f.tagName){
c=c||[];
c.push(f.tagName)
}}}}}
if(c){
o=o||[];
o.push("  ");
o.push(t);
o.push("(");
o.push(c.join(","));
o.push(")\n")
}}
if(o){
n.push("The element ");
n.push(h.tagName);
n.push("#");
n.push(h.id||"noId");
n.push("has the following handlers that may cause cirular references: \n");
n.push(o.join(""))
}
var a=h.childNodes;
for(var s=0,l=a.length;
s<l;
s++){
this._postDisposeElementCheck(n,a[s])
}}
}};
