
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("NotebookCore")){
if(AjxPackage.define("zimbraMail.notebook.model.ZmNotebook")){
ZmNotebook=function(e){
e.type=ZmOrganizer.NOTEBOOK;
ZmOrganizer.call(this,e)
};
ZmNotebook.prototype=new ZmOrganizer;
ZmNotebook.prototype.constructor=ZmNotebook;
ZmNotebook.PAGE_INDEX="_Index";
ZmNotebook.PAGE_CHROME="_Template";
ZmNotebook.PAGE_CHROME_STYLES="_TemplateStyles";
ZmNotebook.PAGE_TITLE_BAR="_TitleBar";
ZmNotebook.PAGE_HEADER="_Header";
ZmNotebook.PAGE_FOOTER="_Footer";
ZmNotebook.PAGE_SIDE_BAR="_SideBar";
ZmNotebook.PAGE_TOC_BODY_TEMPLATE="_TocBodyTemplate";
ZmNotebook.PAGE_TOC_ITEM_TEMPLATE="_TocItemTemplate";
ZmNotebook.PATH_BODY_TEMPLATE="_PathBodyTemplate";
ZmNotebook.PATH_ITEM_TEMPLATE="_PathItemTemplate";
ZmNotebook.PATH_SEPARATOR="_PathSeparator";
ZmNotebook.prototype.toString=function(){
return"ZmNotebook"
};
ZmNotebook.prototype.getIcon=function(){
if(this.nId==ZmOrganizer.ID_ROOT){
return null
}
if(this.parent.nId==ZmOrganizer.ID_ROOT){
return this.link?"SharedNotebook":"Notebook"
}
return this.link?"SharedSection":"Section"
};
ZmNotebook.prototype.getSearchPath=function(){
var a="Notebook";
var e=ZmMsg.notebookPersonalName;
var t=ZmOrganizer.prototype.getSearchPath.call(this);
if(t.match(new RegExp("^"+e+"(/)?"))){
t=a+t.substring(e.length)
}
return t
};
ZmNotebook.prototype.notifyCreate=function(a){
var t=ZmFolderTree.createFromJs(this,a,this.tree);
if(t){
var e=ZmOrganizer.getSortIndex(t,ZmNotebook.sortCompare);
this.children.add(t,e);
t._notify(ZmEvent.E_CREATE)
}};
ZmNotebook.prototype.notifyModify=function(a){
ZmOrganizer.prototype.notifyModify.call(this,a);
var t=false;
var e=new Object();
if(a.name!=null&&this.name!=a.name&&!a._isRemote){
this.name=a.name;
e[ZmOrganizer.F_NAME]=true;
t=true
}else{
if(a.color!=null&&this.color!=a.color&&!a._isRemote){
this.color=a.color;
e[ZmOrganizer.F_COLOR]=true;
t=true
}}
if(t){
this._notify(ZmEvent.E_MODIFY,{
fields:e}
)
}};
ZmNotebook.checkName=function(e){
return ZmOrganizer.checkName(e)
};
ZmNotebook.sortCompare=function(i,a){
var e=ZmOrganizer.checkSortArgs(i,a);
if(e!=null){
return e
}
if(i.link!=a.link){
return i.link?1:-1
}
var o=i.name.toLowerCase();
var t=a.name.toLowerCase();
return AjxStringUtil.natCompare(o,t)
};
ZmNotebook.prototype._delete=function(){
var e=((this.type==ZmOrganizer.FOLDER||this.type==ZmOrganizer.ADDRBOOK)&&(this.nId==ZmFolder.ID_SPAM||this.nId==ZmFolder.ID_TRASH));
if(this.isSystem()&&!e){
return
}
var a=e?"empty":"delete";
var t=new AjxCallback(this,this.deleteCallback);
this._organizerAction({
action:a,callback:t}
)
};
ZmNotebook.prototype.deleteCallback=function(){
if(this._isRemote){
var e=appCtxt.getApp(ZmApp.NOTEBOOK);
e.deleteNotify([this.id])
}};
ZmNotebook.prototype.rename=function(a,o,t,e){
var i=new AjxCallback(this,this.renameCallback,[o,a]);
ZmOrganizer.prototype.rename.call(this,a,i,t,e)
};
ZmNotebook.prototype.renameCallback=function(l,t,n){
var i=(n&&n.getResponse())?n.getResponse():null;
var o=(i&&i.FolderActionResponse)?i.FolderActionResponse.action:null;
var a=o?o.id:"";
var r=o?o.op:"";
var h=/:/.test(a);
if(r=="rename"&&h){
var e=AjxDispatcher.run("GetNotebookCache");
var c=e.getItemInfo({
id:a}
,true);
e.putItem(c);
var s=new Object();
s.name=t;
s.id=c.id;
s.rest=c.getRestUrl();
this._updated=true;
this.notifyModify(s)
}
l.run(n)
};
ZmNotebook.prototype.createQuery=function(t){
if(!this.isRemote()&&this.isSystem()){
var i=ZmFolder.QUERY_NAME[this.nId];
return t?i:("in:"+(i||('"'+this.name+'"')))
}
var o=this.name;
var a=this.parent;
while(a&&(a.nId!=ZmFolder.ID_ROOT)&&a.name.length){
var e=a.isSystem()?ZmFolder.QUERY_NAME[a.nId]:a.name;
o=e+"/"+o;
a=a.parent
}
o='"'+o+'"';
return t?o:("in:"+o)
}
}
if(AjxPackage.define("zimbraMail.notebook.model.ZmNotebookItem")){
ZmNotebookItem=function(e,a,t){
if(arguments.length==0){
return
}
ZmItem.call(this,e,a,t);
this.folderId=ZmNotebookItem.DEFAULT_FOLDER
};
ZmNotebookItem.prototype=new ZmItem;
ZmNotebookItem.prototype.constructor=ZmNotebookItem;
ZmNotebookItem.prototype.toString=function(){
return"ZmNotebookItem"
};
ZmNotebookItem.DEFAULT_FOLDER=ZmOrganizer.ID_NOTEBOOK;
ZmNotebookItem.prototype.name;
ZmNotebookItem.prototype.creator;
ZmNotebookItem.prototype.createDate;
ZmNotebookItem.prototype.modifier;
ZmNotebookItem.prototype.modifyDate;
ZmNotebookItem.prototype.size;
ZmNotebookItem.prototype.version=0;
ZmNotebookItem.createFromDom=function(a,e){
var t=new ZmNotebookItem(e.type||-1,a.id,e.list);
t.set(a);
return t
};
ZmNotebookItem.prototype.getPath=function(a){
var t=appCtxt.getById(this.folderId);
var e=!a?this.name:"";
return[t.getPath(),"/",e].join("")
};
ZmNotebookItem.prototype.getRestUrl=function(t){
var e=ZmItem.prototype.getRestUrl.call(this);
if(t){
e=e?e.replace(new RegExp(("/"+this.name+"(/)?$")),""):null
}
return e
};
ZmNotebookItem.prototype.set=function(e){
this.id=e.id;
this.restUrl=e.rest!=null?e.rest:this.restUrl;
this.folderId=e.l!=null?e.l:this.folderId;
this._parseTags(e.t);
this.name=e.name!=null?e.name:this.name;
this.creator=e.cr!=null?e.cr:this.creator;
this.createDate=e.d!=null?new Date(Number(e.d)):this.createDate;
this.modifier=e.leb!=null?e.leb:this.modifier;
this.modifyDate=e.md!=null?new Date(Number(e.md)):this.modifyDate;
this.size=e.s!=null?Number(e.s):this.size;
this.version=e.ver!=null?Number(e.ver):this.version
}
}
if(AjxPackage.define("zimbraMail.notebook.model.ZmDocument")){
ZmDocument=function(t,e){
ZmNotebookItem.call(this,ZmItem.DOCUMENT,t,e)
};
ZmDocument.prototype=new ZmNotebookItem;
ZmDocument.prototype.constructor=ZmDocument;
ZmDocument.prototype.toString=function(){
return"ZmDocument"
};
ZmDocument.prototype.contentType;
ZmDocument.createFromDom=function(t,e){
var a=new ZmDocument(t.id,e.list);
a.set(t);
return a
};
ZmDocument.prototype.set=function(e){
ZmNotebookItem.prototype.set.call(this,e);
this.contentType=e.ct!=null?e.ct:this.contentType
}
}
if(AjxPackage.define("zimbraMail.notebook.model.ZmPage")){
ZmPage=function(t,e){
ZmNotebookItem.call(this,ZmItem.PAGE,t,e)
};
ZmPage.prototype=new ZmNotebookItem;
ZmPage.prototype.constructor=ZmPage;
ZmPage.prototype.toString=function(){
return"ZmPage"
};
ZmPage.load=function(t,i,e,s,a,n){
var o=new ZmPage();
o.folderId=t;
o.name=i;
o.load(e,s,a,n);
return o
};
ZmPage.save=function(e,a,i,n,t){
var o=new ZmPage();
o.folderId=e;
o.name=a;
o._content=i;
o.save(n,t)
};
ZmPage.createFromDom=function(i,a){
var o=new ZmPage(null,a.list);
o.set(i);
var e=appCtxt.getApp(ZmApp.NOTEBOOK);
var t=e.getNotebookCache();
t.putPage(o);
return o
};
ZmPage.prototype.getPath=function(){
var e=this.name==ZmNotebook.PAGE_INDEX;
return ZmNotebookItem.prototype.getPath.call(this,e)
};
ZmPage.prototype.getRestUrl=function(e){
var t=e||(this.name==ZmNotebook.PAGE_INDEX);
return ZmNotebookItem.prototype.getRestUrl.call(this,t)
};
ZmPage.prototype.setContent=function(e){
this._content=e
};
ZmPage.prototype.getContent=function(t,e){
if(this.name&&this._content==null&&this.version!=0){
this.load(this.version,t,e)
}else{
if(t){
t.run()
}}
return this._content
};
ZmPage.prototype.getNotebook=function(){
if(!this._notebook){
var t=appCtxt.getById(this.folderId);
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
while(t&&t.parent&&(t.parent.id!=e)){
t=t.parent
}
this._notebook=t
}
return this._notebook
};
ZmPage.prototype.isShared=function(){
var e=this.getNotebook();
return e&&e.link
};
ZmPage.prototype.isFolderReadOnly=function(){
var t=false;
var a=appCtxt.getById(this.folderId);
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
while(a&&a.parent&&(a.parent.id!=e)&&!a.isReadOnly()){
a=a.parent
}
if(a&&a.isReadOnly()){
t=true
}
return t
};
ZmPage.prototype.isReadOnly=function(){
if(this.isIndex()){
return true
}
var a=false;
var t=appCtxt.getById(this.folderId);
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
while(t&&t.parent&&(t.parent.id!=e)&&!t.isReadOnly()){
t=t.parent
}
if(t&&t.isReadOnly()){
a=true
}
return a
};
ZmPage.prototype.isChildOf=function(t){
var a=appCtxt.getById(this.folderId);
if(this.folderId==t){
return true
}
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
while(a&&a.id&&(a.id!=e)){
if(a.id==t){
return true
}
a=a.parent
}
return false
};
ZmPage.prototype.isIndex=function(){
return((this.name==ZmNotebook.PAGE_INDEX)&&(!this._customIndexPage))
};
ZmPage.prototype.save=function(o,t){
var a=AjxSoapDoc.create("SaveWikiRequest","urn:zimbraMail",null);
var e=a.set("w",this._content);
e.setAttribute("name",this.name);
if(this.id&&this.version){
e.setAttribute("id",this.id);
e.setAttribute("ver",this.version)
}
if(this.folderId){
e.setAttribute("l",this.folderId)
}
var i={
soapDoc:a,asyncMode:true,callback:o,errorCallback:t};
appCtxt.getAppController().sendRequest(i)
};
ZmPage.prototype.load=function(n,l,o,e){
var s=AjxSoapDoc.create("GetWikiRequest","urn:zimbraMail");
var r=s.set("w");
if(this.id){
r.setAttribute("id",this.id)
}else{
r.setAttribute("name",this.name);
if(this.folderId){
r.setAttribute("l",this.folderId)
}}
if(n){
r.setAttribute("ver",n)
}
if(e||(e==null&&this.name.match(/^_/))){
r.setAttribute("tr","1")
}
var i=l?new AjxCallback(this,this._loadHandleResponse,[l]):null;
var a={
soapDoc:s,asyncMode:Boolean(i),callback:i,errorCallback:o,noBusyOverlay:false};
var h=appCtxt.getAppController();
var t=h.sendRequest(a);
if(!a.asyncMode){
this._loadHandleResponse(l,t)
}};
ZmPage.prototype.set=function(t){
var e=this.version;
ZmNotebookItem.prototype.set.call(this,t);
if(t.fr!=null){
this.fragment=t.fr instanceof Array?t.fr[0]._content:t.fr
}
if(e!=this.version&&t.body==null){
this._content=null
}else{
if(t.body!=null){
this._content=(t.body instanceof Array)?t.body[0]._content:t.body
}}};
ZmPage.prototype._loadHandleResponse=function(i,e){
var t=e&&e.GetWikiResponse&&e.GetWikiResponse.w;
if(t){
var a=e.GetWikiResponse.w[0];
this.set(a)
}
if(i){
i.run(this)
}}
}
if(AjxPackage.define("zimbraMail.notebook.model.ZmPageList")){
ZmPageList=function(e,t){
ZmList.call(this,t||ZmItem.PAGE,e)
};
ZmPageList.prototype=new ZmList;
ZmPageList.prototype.constructor=ZmPageList;
ZmPageList.prototype.toString=function(){
return"ZmPageList"
}
}
if(AjxPackage.define("zimbraMail.notebook.model.ZmNotebookCache")){
ZmNotebookCache=function(){
this.clearCache();
this._changeListener=new AjxListener(this,this._handleChange)
};
ZmNotebookCache._SPECIAL_NAMES={};
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_INDEX]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_CHROME]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_CHROME_STYLES]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_TITLE_BAR]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_HEADER]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_FOOTER]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_SIDE_BAR]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_TOC_BODY_TEMPLATE]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PAGE_TOC_ITEM_TEMPLATE]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PATH_BODY_TEMPLATE]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PATH_ITEM_TEMPLATE]=true;
ZmNotebookCache._SPECIAL_NAMES[ZmNotebook.PATH_SEPARATOR]=true;
ZmNotebookCache._SPECIAL_CONTENT={};
ZmNotebookCache._SPECIAL_CONTENT[ZmNotebook.PAGE_INDEX]="<wiklet class='TOC'/>";
ZmNotebookCache._SPECIAL_CONTENT[ZmNotebook.PAGE_CHROME]=["<div style='margin:0.5em'>","<h1><wiklet class='NAME'/></h1>","<div class='ZmStatusWarningToast' style='margin:1em'>",ZmMsg.wikiTemplatesMissing,"</div>","<div>","<wiklet class='CONTENT'/>","</div>","</div>"].join("");
ZmNotebookCache.prototype._idMap;
ZmNotebookCache.prototype._foldersMap;
ZmNotebookCache.prototype._pathMap;
ZmNotebookCache.prototype._idPathMap;
ZmNotebookCache.prototype._idxPageMap;
ZmNotebookCache.prototype._changeListener;
ZmNotebookCache.prototype.fillCache=function(e,d,o){
var m=appCtxt.getFolderTree();
var r=AjxUtil.isNumeric(e)?e:['"',e,'"'].join("");
var u="inid:"+r;
var h=AjxSoapDoc.create("SearchRequest","urn:zimbraMail");
var n=[ZmSearch.TYPE[ZmItem.PAGE],ZmSearch.TYPE[ZmItem.DOCUMENT]];
h.setMethodAttribute("types",n.join());
h.setMethodAttribute("limit","250");
var l=h.set("query",u);
var s=d?[null,e,d,o]:null;
var i=d?new AjxCallback(this,this._fillCacheResponse,s):null;
var a={
soapDoc:h,asyncMode:Boolean(i),callback:i,errorCallback:o,noBusyOverlay:false};
if(s){
s[0]=a
}
var c=appCtxt.getAppController();
var t=c.sendRequest(a);
if(!a.asyncMode){
this._fillCacheResponse(a,e,null,o,t)
}};
ZmNotebookCache.prototype.putItem=function(t,o){
var e=t.folderId||ZmNotebookItem.DEFAULT_FOLDER;
var i=this.getPage(t);
if(i.id){
this._idMap[i.id]=i;
if(i.path){
this._pathMap[i.path]=i;
this._idPathMap[i.id]=i.path
}else{
var a=i.getRestUrl();
var s=this.getPath(a);
this._pathMap[s]=i;
this._idPathMap[i.id]=s
}}
if(this._foldersMap[e]!=null){
this._foldersMap[e].all[i.name]=i;
if(i instanceof ZmPage){
this._foldersMap[e].pages[i.name]=i
}else{
if(i instanceof ZmDocument){
this._foldersMap[e].docs[i.name]=i
}}}
var n=i.remoteFolderId;
if(n){
if(!this._foldersMap[n]){
this._foldersMap[n]=this._foldersMap[e]
}}
i.addChangeListener(this._changeListener)
};
ZmNotebookCache.prototype.putPage=function(t,e){
this.putItem(t)
};
ZmNotebookCache.prototype.putDocument=function(t,e){
this.putItem(t,e)
};
ZmNotebookCache.prototype.renameItem=function(t,e){
this.removeItem(t);
t.name=e;
this.putItem(t)
};
ZmNotebookCache.prototype.renamePage=function(t,e){
this.renameItem(t,e)
};
ZmNotebookCache.prototype.renameDocument=function(t,e){
this.renameItem(t,e)
};
ZmNotebookCache.prototype.removeItem=function(t){
if(!t){
return
}
if(t.path){
delete this._pathMap[t.path]
}
if(t.id){
delete this._idPathMap[t.id];
delete this._idMap[t.id];
delete this._idxPageMap[t.id]
}
if(t.folderId){
delete this._idxPageMap[t.folderId]
}
var e=this.getItemsInFolder(t.folderId);
delete e.all[t.name];
if(t instanceof ZmPage){
delete e.pages[t.name]
}else{
if(t instanceof ZmDocument){
delete e.docs[t.name]
}}
var a=t.remoteFolderId;
if(a){
var e=this.getItemsInFolder(a);
delete e.all[t.name];
if(t instanceof ZmPage){
delete e.pages[t.name]
}else{
if(t instanceof ZmDocument){
delete e.docs[t.name]
}}}
t.removeChangeListener(this._changeListener)
};
ZmNotebookCache.prototype.removePage=function(e){
this.removeItem(e)
};
ZmNotebookCache.prototype.removeDocument=function(e){
this.removeItem(e)
};
ZmNotebookCache.prototype.clearCache=function(){
this._idMap={};
this._foldersMap={};
this._pathMap={};
this._idPathMap={};
this._idxPageMap={}
};
ZmNotebookCache.prototype.getPaths=function(){
return this._pathMap
};
ZmNotebookCache.prototype.getIds=function(){
return this._idMap
};
ZmNotebookCache.prototype.getFolders=function(){
return this._foldersMap
};
ZmNotebookCache.prototype.getItemByPath=function(e){
return this._pathMap[e]
};
ZmNotebookCache.prototype.getItemById=function(e){
return this._idMap[e]
};
ZmNotebookCache.prototype.getPageById=function(t){
var e=this._idMap[t];
return e instanceof ZmPage?e:null
};
ZmNotebookCache.prototype.getDocumentById=function(t){
var e=this._idMap[t];
return e instanceof ZmDocument?e:null
};
ZmNotebookCache.prototype.getItemByName=function(e,a,o){
var t=this.getItemsInFolder(e);
var i=t.pages[a]||t.docs[a];
return i
};
ZmNotebookCache.prototype.getPageByName=function(o,t,n){
var p=this.getItemByName(o,t,n);
if(p){
return p instanceof ZmPage?p:null
}
if(t in ZmNotebookCache._SPECIAL_NAMES){
var d=AjxSoapDoc.create("BatchRequest","urn:zimbra");
d.setMethodAttribute("onerror","continue");
for(var l in ZmNotebookCache._SPECIAL_NAMES){
if(this._foldersMap[o].pages[l]){
continue
}
var a=d.set("GetWikiRequest",null,null,"urn:zimbraMail");
a.setAttribute("requestId",l);
var u=d.set("w",null,a);
u.setAttribute("l",o);
u.setAttribute("name",l);
u.setAttribute("tr",1)
}
var r={
soapDoc:d,asyncMode:false,callback:null,errorCallback:null};
var f=appCtxt.getAppController();
var s=f.sendRequest(r);
var m=s&&s.BatchResponse;
var g=m&&m.GetWikiResponse;
if(g){
for(var h=0;
h<g.length;
h++){
var e=g[h].w[0];
var c=this.getPageById(e.id);
if(!c){
c=new ZmPage();
c.set(e);
if(c.folderId!=o){
c.id=0;
c.folderId=o;
c.version=0
}
this.putPage(c)
}else{
c.set(e);
c.folderId=o
}}}
for(var l in ZmNotebookCache._SPECIAL_CONTENT){
if(this._foldersMap[o].pages[l]){
continue
}
var c=new ZmPage();
c.name=l;
c.folderId=o;
c.setContent(ZmNotebookCache._SPECIAL_CONTENT[l]);
this.putPage(c)
}
return this._foldersMap[o].pages[t]
}
return null
};
ZmNotebookCache.prototype.getDocumentByName=function(e,t,i){
var a=this.getItemByName(e,t,i);
return a instanceof ZmDocument?a:null
};
ZmNotebookCache.prototype.getItemByLink=function(n){
var d;
if(d=n.match(/^\/\/([^\/]+)(?:\/(.*))?/)){
if(!d[2]){
n=n.replace(/\/?$/,"/Notebook/"+ZmNotebook.PAGE_INDEX)
}
var v=AjxSoapDoc.create("BatchRequest","urn:zimbra");
var h=v.set("GetWikiRequest",null,null,"urn:zimbraMail");
h.setAttribute("id","exact");
var w=v.set("w",null,h);
w.setAttribute("name",n);
var h=v.set("GetWikiRequest",null,null,"urn:zimbraMail");
h.setAttribute("id","index");
var w=v.set("w",null,h);
w.setAttribute("name",n.replace(/\/?$/,"/")+ZmNotebook.PAGE_INDEX);
w.setAttribute("tr",1);
var g={
soapDoc:v,asyncMode:false,callback:null,errorCallback:null};
var b=appCtxt.getAppController();
var t=b.sendRequest(g);
return this._getPageByLinkResponse(t)
}
var s=null;
if(n.match(/^\//)){
var y=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
s=appCtxt.getById(y);
n=n.substr(1)
}
if(!s){
var r=appCtxt.getApp(ZmApp.NOTEBOOK);
var c=r.getNotebookController();
var u=c.getPage();
var e=(u&&u.folderId)||ZmOrganizer.ID_NOTEBOOK;
s=appCtxt.getById(e)
}
if(n.match(/\//)){
var l=n.replace(/\/$/,"").split("/");
for(var f=0;
f<l.length-1;
f++){
var k=l[f];
if(k=="."){
continue
}
if(k==".."){
if(s==null){
return null
}
s=s.parent;
continue
}
s=ZmNotebookCache.__getNotebookByName(s,k);
if(s==null){
throw"subfolder doesn't exist: "+(l.slice(0,f+1).join("/"))
}}
n=l[l.length-1]
}
var o=ZmNotebookCache.__getNotebookByName(s,n);
if(o){
s=o;
n=ZmNotebook.PAGE_INDEX
}
var a=Boolean(n.match(/^_/));
var p=s?this.getItemByName(s.id,n,a):null;
return p
};
ZmNotebookCache.prototype.getPageByLink=function(t){
var e=this.getItemByLink(t);
return e instanceof ZmPage?e:null
};
ZmNotebookCache.prototype.getDocumentByLink=function(t){
var e=this.getItemByLink(t);
return e instanceof ZmDocument?e:null
};
ZmNotebookCache.prototype._getPageByLinkResponse=function(t){
var o=t&&t._data&&t._data.BatchResponse;
var e=o&&o.GetWikiResponse;
var i=e&&e.w&&e.w[0];
if(i){
var a=this.getPageById(i.id);
if(!a){
a=new ZmPage();
a.set(i);
this.putPage(a)
}else{
a.set(i)
}
return a
}
return null
};
ZmNotebookCache.__getNotebookByName=function(a,e){
if(e=="."){
return a
}
if(e==".."){
return a.parent
}
var n=a?a.children.getArray():[];
for(var t=0;
t<n.length;
t++){
var o=n[t];
if(o.name==e){
return o
}}
return null
};
ZmNotebookCache.prototype.getItemsInFolder=function(e){
e=e||ZmNotebookItem.DEFAULT_FOLDER;
if(!this._foldersMap[e]){
this._foldersMap[e]={
all:{}
,pages:{}
,docs:{}};
this.fillCache(e)
}
return this._foldersMap[e]
};
ZmNotebookCache.prototype.getPagesInFolder=function(e){
return this.getItemsInFolder(e).pages
};
ZmNotebookCache.prototype.getDocumentsInFolder=function(e){
return this.getItemsInFolder(e).docs
};
ZmNotebookCache.prototype.makeProxyPage=function(t,e){
t.getContent();
var a=AjxUtil.createProxy(t);
a.id=null;
a.folderId=e;
a.version=0;
return a
};
ZmNotebookCache.prototype._fillCacheResponse=function(v,e,n,r,t){
var h=appCtxt.getById(e);
var o=(h&&h.zid)?h.zid+":"+h.rid:undefined;
if(t&&(t.SearchResponse||t._data.SearchResponse)){
var u=t.SearchResponse||t._data.SearchResponse;
var c=u.w||[];
for(var m=0;
m<c.length;
m++){
var f=c[m];
var y=this.getPageById(f.id);
if(!y){
y=new ZmPage();
y.set(f);
y.folderId=e;
y.remoteFolderId=o;
this.markCustomIndexPage(y);
this.putPage(y,true)
}else{
y.set(f)
}
if((y.name=="_Index")&&(o!=null)){
this._updateIndexItem(e,o,f)
}}
var l=u.doc||[];
for(var m=0;
m<l.length;
m++){
var k=l[m];
var y=this.getDocumentById(k.id);
if(!y){
y=new ZmDocument();
y.set(k);
y.folderId=e;
y.remoteFolderId=o;
this.putDocument(y,true)
}else{
y.set(k)
}}
if(u.more&&v){
var x=v.soapDoc;
var g=Number(x.getMethod().getAttribute("limit"))*2;
x.setMethodAttribute("offset",u.offset+c.length);
x.setMethodAttribute("limit",g);
var s=x.getHeader();
s.parentNode.removeChild(s);
var w=appCtxt.getAppController();
var t=w.sendRequest(v);
if(!v.asyncMode){
this._fillCacheResponse(v,e,null,r,t)
}
return
}}
if(o){
var x=AjxSoapDoc.create("GetFolderRequest","urn:zimbraMail");
var d=x.set("folder");
d.setAttribute("l",o);
var a=[e,n,r];
var p=new AjxCallback(this,this._fillCacheResponse2,a);
var b={
soapDoc:x,asyncMode:Boolean(p),callback:p,errorCallback:r};
var w=appCtxt.getAppController();
w.sendRequest(b)
}else{
if(n){
n.run(e,t)
}}};
ZmNotebookCache.prototype._updateIndexItem=function(t,i,a){
var e=this.getPageById(t);
if(!e){
e=new ZmPage();
e.set(a);
e.id=t;
e.folderId=t;
e.remoteFolderId=i;
this.markCustomIndexPage(e);
this.putPage(e,true)
}else{
e.set(a);
e.id=t
}};
ZmNotebookCache.prototype._fillCacheResponse2=function(t,d,h,n){
var u=appCtxt.getFolderTree();
var o=n.GetFolderResponse||(n._data&&n._data.GetFolderResponse);
var e=o.folder&&o.folder[0];
var a=e&&e.folder;
var c=appCtxt.getById(t);
if(a&&c){
for(var r=0;
r<a.length;
r++){
var s=a[r];
var l=appCtxt.getById(s.id);
if(l){
c.children.remove(l);
l._updated=true;
l._notify(ZmEvent.E_DELETE)
}
var l=ZmFolderTree.createFromJs(c,s,u);
l._updated=true;
c.children.add(l);
l._notify(ZmEvent.E_CREATE)
}}
if(d){
d.run(t,n)
}};
ZmNotebookCache.prototype._handleChange=function(e){};
ZmNotebookCache.prototype._processResponse=function(t){
try{
var l=[];
if(!t){
return l
}
var s=t.w||[];
for(var a=0;
a<s.length;
a++){
var e=s[a];
var h=this.getPageById(e.id);
if(!h){
h=new ZmPage();
h.set(e);
h.folderId=e.l||ZmNotebookItem.DEFAULT_FOLDER;
this.putPage(h)
}else{
h.set(e)
}
l.push(h)
}
var o=t.doc||[];
for(var a=0;
a<o.length;
a++){
var r=o[a];
var h=this.getDocumentById(r.id);
if(!h){
h=new ZmDocument();
h.set(r);
h.folderId=r.l||ZmNotebookItem.DEFAULT_FOLDER;
this.putDocument(h)
}else{
h.set(r)
}
l.push(h)
}
return l
}
catch(n){}};
ZmNotebookCache.prototype.checkCache=function(t){
var e=null;
if(t.folderId&&t.name){
e=this.getItemByName(t.folderId,t.name)
}else{
if(t.id){
e=this.getItemById(t.id)
}else{
if(t.path){
e=this.getItemByPath(t.path)
}}}
return e
};
ZmNotebookCache.prototype.getItemInfo=function(a,i){
var c=this.checkCache(a);
if(c&&!i){
if(a.callback){
a.callback.run(c)
}
return c
}
var r=AjxSoapDoc.create("GetItemRequest","urn:zimbraMail");
var o=r.set("item");
if(a.path){
o.setAttribute("path",a.path)
}else{
if(a.folderId&&a.id){
o.setAttribute("l",a.folderId);
o.setAttribute("id",a.id)
}else{
if(a.folderId&&a.name){
o.setAttribute("l",a.folderId);
o.setAttribute("name",a.name)
}else{
if(a.id){
o.setAttribute("id",a.id)
}}}}
var s=[];
var e=(a.callback?true:false);
var n=null;
if(e){
n=new AjxCallback(this,this.handleGetItemResponse,[a])
}
var l={
soapDoc:r,asyncMode:e,callback:n,accountName:a.accountName};
var h=appCtxt.getAppController();
var t=h.sendRequest(l);
if(!e&&t){
var c=this.handleGetItemResponse(a,t.GetItemResponse);
return c
}
return null
};
ZmNotebookCache.prototype.handleGetItemResponse=function(e,t){
try{
var h=e.path;
var n=e.callback;
var r=t;
if(t&&t._data){
r=t&&t._data&&t._data.GetItemResponse
}
var a=r&&r.folder&&r.folder[0];
var l=r&&r.w&&r.w[0];
var o=r&&r.link&&r.link[0];
var s=null;
if(a){
s=new ZmPage();
s.set(a);
s.folderId=a.id||ZmNotebookItem.DEFAULT_FOLDER;
s.name="_Index"
}
if(l){
s=new ZmPage();
s.set(l);
s.folderId=l.l||ZmNotebookItem.DEFAULT_FOLDER;
this.markCustomIndexPage(s)
}
if(o){
s=new ZmPage();
s.set(o);
s.folderId=o.id||ZmNotebookItem.DEFAULT_FOLDER;
s.remoteFolderId=(o&&o.zid)?o.zid+":"+o.rid:undefined;
s.name="_Index"
}
if(s&&!e.ignoreCaching){
if(!h){
h=this.getPath(s.restUrl)
}
s.path=h;
this.putItem(s)
}
if(n){
n.run(s)
}
return s
}
catch(i){}};
ZmNotebookCache.prototype.getPath=function(i){
var n=AjxStringUtil.parseURL(i);
if(!n){
return
}
var o=n.path;
if(!o||o=="blank"){
return
}
o=unescape(o);
if(o.charAt(0)=="/"){
o=o.substring(1)
}
var a=null;
var t=null;
var n=o.split("/");
if(n.length>=3&&n[0]=="home"){
var a=n[1];
var e=n.length;
var s=n.splice(2,e-2);
t=s.join("/");
return t
}
return o
};
ZmNotebookCache.prototype.markCustomIndexPage=function(e){
if(e.name=="_Index"){
e._customIndexPage=true;
this._idxPageMap[e.id]=e;
this._idxPageMap[e.folderId]=e;
if(this._idMap[e.folderId]!=null){
this._idMap[e.folderId]._customIndexPage=true
}}};
ZmNotebookCache.prototype.getPage=function(e){
if(e.name=="_Index"){
if(this._idxPageMap[e.id]){
return this._idxPageMap[e.id]
}else{
if(this._idxPageMap[e.folderId]){
return this._idxPageMap[e.folderId]
}}}
return e
};
ZmNotebookCache.prototype.updateItems=function(e,t,a){
this._updateOrganizers(e,t,a);
this._updateCacheItems(e,t,a)
};
ZmNotebookCache.prototype._updateOrganizers=function(e,t,r){
var o=appCtxt.getById(e);
if(!o){
return
}
var s=o?o.children.getArray():[];
for(var a=0;
a<s.length;
a++){
var n=s[a];
if(n&&n.restUrl){
n.restUrl=n.restUrl.replace(t,r)
}
if(n){
this._updateOrganizers(n.id,t,r);
this._updateCacheItems(n.id,t,r)
}}};
ZmNotebookCache.prototype._updateCacheItems=function(t,a,r){
var s=this._foldersMap[t];
if(!s){
return
}
var e=s.pages;
for(var o in e){
var n=e[o];
if(n&&n.restUrl){
n.restUrl=n.restUrl.replace(a,r)
}}}
}};
